

subroutine common_block_SIMCE(epsilon_pSIMCE)


USE VarDef
!USE Datasets
USE PROBABILITY
IMPLICIT NONE

real(8), intent(out) ::  epsilon_pSIMCE(3,n_svd,D)  !Psi_cSIMCE(n_s,NCType), 

integer              :: idum, i, stopping, mkt, ctype, wtype, sim
real(8)              :: epsilon_pvec(3*n_svd*D)
real(8)              :: actual_mean







!shocks
! Draw D draws for every household, and shock type
!$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
idum=7777
call gasdev(idum,epsilon_pvec,3*n_svd*D)



actual_mean=0.0d0
do i=1,3*n_svd*D
actual_mean=actual_mean+epsilon_pvec(i)/(3.0d0*dble(n_svd)*dble(D))
end do

do i=1,3*n_svd*D
epsilon_pvec(i)=epsilon_pvec(i)-actual_mean
end do



do i=1,n_svd
 do sim=1,D
  epsilon_pSIMCE(1,i,sim)=exp(theta(156))*epsilon_pvec(i+(sim-1)*n_svd)          !production of cogn ach in M
   
  epsilon_pSIMCE(2,i,sim)=exp(theta(157))*epsilon_pvec(n_svd*D+i+(sim-1)*n_svd)  !production of cogn ach in V
  epsilon_pSIMCE(3,i,sim)=exp(theta(155))*epsilon_pvec(2*n_svd*D+i+(sim-1)*n_svd)!preference for M
 end do 
end do




end subroutine common_block_SIMCE