 
                     
subroutine simulate_simce2(zeroSM, zeroSV, awM,awV,epsilon_pSIMCE, simcV_uncondSIMCE,simcaM_uncondSIMCE,simcaV_uncondSIMCE,sim_apv_uncond , simcasqM_uncondSIMCE, simcasqV_uncondSIMCE, sim_sqapv_uncond, noevalSIMCE )
USE VarDef
USE Datasets
IMPLICIT NONE


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                     !
! Variable declaration                !
!                                     !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(8), intent(in)  :: awM(n_mkt),awV(n_mkt)
real(8), intent(in)  :: epsilon_pSIMCE(3,n_s,D) ! Psi_cSIMCE(n_s,NCType),
integer, intent(in)  :: zeroSM(n_mkt), zeroSV(n_mkt)

!unconditional choice of sector
real(8), intent(out) :: simcV_uncondSIMCE(n_s)

!unconditional test score conditional on sector, and their squares
real(8), intent(out) :: simcaM_uncondSIMCE(n_s), simcaV_uncondSIMCE(n_s), simcasqM_uncondSIMCE(n_s), simcasqV_uncondSIMCE(n_s)

!unconditional tuition conditional on sector Vand its square
real(8), intent(out) ::sim_apv_uncond(n_s), sim_sqapv_uncond(n_s)



!index
integer, intent(out) :: noevalSIMCE


real(8)  :: pv_h(n_s), ucM(NCType),ucV(NCType), awM_scalar, awV_scalar, ucmax(NCType)

!unconditional choice of sector M (not intent out for collinearity of moments)
real(8)  :: simcM_uncondSIMCE(n_s)

!outcomes conditional on type and simulation number
real(8)  :: simcM(n_s,NCType,D), simcV(n_s,NCType,D) , simca(n_s,NCType,D)
real(8)  :: apv(n_s,NCType,D)


!outcomes conditional on type
real(8)  :: simcaM_nosim(n_s,NCType), simcasqM_nosim(n_s,NCType), simcaV_nosim(n_s,NCType), simcasqV_nosim(n_s,NCType) 
real(8)  :: simcV_nosim(n_s,NCType), sim_apv_nosim(n_s,NCType), sim_sqapv_nosim(n_s,NCType)


!denominator used to integrate out type 
!real(8)  :: den_simcaM_notype(n_s,D), den_simcaV_notype(n_s,D), simcV_notype(n_s,D)

 
!type probs and number of accepted simulations (I use the crude frequency simulator to draw shocks conditional on choice of a certain sector)
real(8)  :: Psi(3), SStarM(n_s,NCType), SStarV(n_s,NCTYpe)

         

integer :: i, sim, ctype, stopping, cat, mkt

real(8)   :: beta0M(n_s), beta0V(n_s)  !this is the constant for type 1 and it varies by mkt
real(8)   :: beta0V_21(n_s), beta0V_31(n_s) !these are the type specific differences, which vary by market. Without these I cant fit the distribution of test scores i nV

real(8)  :: simavg_tsMall, simavg_tsVall

integer  :: arbitrary_M(n_s,NCType), arbitrary_V(n_s,NCType) !count how often I need to draws an arbitrarily large numbers
real(8)  :: fracarbM(NCType), fracarbV(NCType)
real(8)  :: avg_simtsM, avg_simtsV

           




simca=0.0d0

noevalSIMCE=0


!write(*,*) "Inside subroutine that simulates simce"

!Computing individual level price that each family would have to pay if they chose the V school in their market 
!This depends on the fellowship that each family is eligible for
    
    do i=1,n_s   


       pv_h(i)=theta(162)+theta(163)*(1.20d0)+theta(164)*dble(primaria_s(i))+theta(165)*dble(nfam_s(i))+& !theta(166)*dble(peduc_s(i))+ theta(176)*dble(Central(mkt7_s(i)))&
               &theta(169)*dble(rural_s(i))+theta(171)*mincome_s(i)
    
      if(pv_h(i)>1.2-voucher) then
        pv_h(i)=1.2
      else if (pv_h(i)<0.0d0) then      
        pv_h(i)=0.0d0
      end if  
  

     sim_apv_uncond(i)=pv_h(i)
     sim_sqapv_uncond(i)=pv_h(i)**2.0d0



  !Assign correct beta0M and beta0V
  if(mkt7_s(i).eq.1) then
     beta0M(i)=theta(110)
     beta0V(i)=theta(113)

     
  
   else if (mkt7_s(i).eq.2) then
     beta0M(i)=theta(199)
     beta0V(i)=theta(216)

  
   else if (mkt7_s(i).eq.3) then
     beta0M(i)=theta(200)
     beta0V(i)=theta(217)
     beta0V_21(i)=theta(254)
     beta0V_31(i)=theta(271)


   else if (mkt7_s(i).eq.4) then
     beta0M(i)=theta(201)
     beta0V(i)=theta(218)



   else if (mkt7_s(i).eq.5) then
     beta0M(i)=theta(202)
     beta0V(i)=theta(219)




   else if (mkt7_s(i).eq.6) then
     beta0M(i)=theta(203)
     beta0V(i)=theta(220)




   else if (mkt7_s(i).eq.7) then
     beta0M(i)=theta(204)
     beta0V(i)=theta(221)




   else if (mkt7_s(i).eq.8) then
     beta0M(i)=theta(205)
     beta0V(i)=theta(222)




   else if (mkt7_s(i).eq.9) then
     beta0M(i)=theta(206)
     beta0V(i)=theta(223)




   else if (mkt7_s(i).eq.10) then
     beta0M(i)=theta(207)
     beta0V(i)=theta(224)




   else if (mkt7_s(i).eq.11) then
     beta0M(i)=theta(208)
     beta0V(i)=theta(225)





   else if (mkt7_s(i).eq.12) then
     beta0M(i)=theta(209)
     beta0V(i)=theta(226)




   else if (mkt7_s(i).eq.13) then
     beta0M(i)=theta(210)
     beta0V(i)=theta(227)




   else if (mkt7_s(i).eq.14) then
     beta0M(i)=theta(211)
     beta0V(i)=theta(228)




   else if (mkt7_s(i).eq.15) then
     beta0M(i)=theta(212)
     beta0V(i)=theta(229)




   else if (mkt7_s(i).eq.16) then
     beta0M(i)=theta(213)
     beta0V(i)=theta(230)




   else if (mkt7_s(i).eq.17) then
     beta0M(i)=theta(214)
     beta0V(i)=theta(231)




   else if (mkt7_s(i).eq.18) then
     beta0M(i)=theta(215)
     beta0V(i)=theta(232)



   end if


    end do !i





!############### Compute simulated choices of parents #########################################
!############### Compute simulated accepted test scores of kids (=0 if sector not chosen) #####
!choice probabilities of parents given teachers' abilities

 



do i=1,n_s
 
  do sim=1,D
  ucM(1)=beta0M(i)+theta(116)*awM(mkt7_s(i))+theta(119)*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+theta(120)*dble(peduc_s(i))+&
         &+epsilon_pSIMCE(1,i,sim)+theta(123)*log(mincome_s(i))+theta(124)+theta(234)*dble(primaria_s(i))+theta(235)*dble(rural_s(i))+epsilon_pSIMCE(3,i,sim) 
  ucM(2)=beta0M(i)+theta(111)+(theta(116)+theta(117))*awM(mkt7_s(i))+(theta(119)+theta(249))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+(theta(120)+theta(251))*dble(peduc_s(i))+&
         &theta(196)*awM(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+&
         &epsilon_pSIMCE(1,i,sim)+(theta(123)+theta(197))*log(mincome_s(i))+theta(124)+theta(125)+theta(234)*dble(primaria_s(i))+theta(235)*dble(rural_s(i))+epsilon_pSIMCE(3,i,sim)  
  ucM(3)=beta0M(i)+theta(112)+(theta(116)+theta(118))*awM(mkt7_s(i))+(theta(119)+theta(250))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
         &(theta(120)+theta(252))*dble(peduc_s(i))+theta(196)*awM(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+&
         &epsilon_pSIMCE(1,i,sim)+(theta(123)+theta(198))*log(mincome_s(i))+theta(124)+theta(126)+theta(234)*dble(primaria_s(i))+theta(235)*dble(rural_s(i))+epsilon_pSIMCE(3,i,sim)
         
  ucV(1)=beta0V(i)+theta(242)*awV(mkt7_s(i))+theta(236)*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+theta(239)*dble(peduc_s(i))+&
        &theta(248)*awV(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+&
        &epsilon_pSIMCE(2,i,sim)+theta(123)*log(mincome_s(i)-pv_h(i))
  ucV(2)=beta0V(i)+theta(114)+(theta(242)+theta(243))*awV(mkt7_s(i))+(theta(236)+theta(237))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
        &(theta(239)+theta(240))*dble(peduc_s(i))+theta(248)*awV(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+&
        &epsilon_pSIMCE(2,i,sim)+(theta(123)+theta(197))*log(mincome_s(i)-pv_h(i)) 
  ucV(3)=beta0V(i)+theta(115)+(theta(242)+theta(244))*awV(mkt7_s(i))+(theta(236)+theta(238))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
        &(theta(239)+theta(241))*dble(peduc_s(i))+theta(248)*awV(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+&
        &epsilon_pSIMCE(2,i,sim)+(theta(123)+theta(198))*log(mincome_s(i)-pv_h(i))
        
      do ctype=1,NCType
      if(mincome_s(i)-pv_h(i)>0) then
         ucmax(ctype)=max(ucM(ctype),ucV(ctype)) 
      else if (mincome_s(i)-pv_h(i)<=0.0d0) then
         ucmax(ctype)=ucM(ctype)
      end if
     
     if(ucmax(ctype)==ucM(ctype)) then
         simcM(i,ctype,sim)=1.0d0
         simcV(i,ctype,sim)=0.0d0
            !cognitive achievement in M = test scores
            if(ctype.eq.1) then
            
              simca(i,ctype,sim)=beta0M(i)+theta(116)*awM(mkt7_s(i))+theta(119)*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+theta(120)*dble(peduc_s(i))+&
                   &theta(196)*awM(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+epsilon_pSIMCE(1,i,sim)
                   
           else if (ctype.eq.2) then
              simca(i,ctype,sim)=beta0M(i)+theta(111)+(theta(116)+theta(117))*awM(mkt7_s(i))+(theta(119)+theta(249))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                             & (theta(120)+theta(251))*dble(peduc_s(i))+&
                   &theta(196)*awM(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+epsilon_pSIMCE(1,i,sim) 
            else if (ctype.eq.3) then
              simca(i,ctype,sim)=beta0M(i)+theta(112)+(theta(116)+theta(118))*awM(mkt7_s(i))+(theta(119)+theta(250))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                   &(theta(120)+theta(252))*dble(peduc_s(i))+theta(196)*awM(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+epsilon_pSIMCE(1,i,sim)
            end if
                 
     else if (ucmax(ctype)==ucV(ctype)) then
         simcM(i,ctype,sim)=0.0d0
         simcV(i,ctype,sim)=1.0d0
           !cognitive achievement in V = test scores
           if(ctype.eq.1) then
            
            simca(i,ctype,sim)=beta0V(i)+theta(242)*awV(mkt7_s(i))+theta(236)*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+theta(239)*dble(peduc_s(i))+&
                               &theta(248)*awV(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+&
                               &epsilon_pSIMCE(2,i,sim)
              
                 
             else if (ctype.eq.2) then
             simca(i,ctype,sim)=beta0V(i)+theta(114)+(theta(242)+theta(243))*awV(mkt7_s(i))+(theta(236)+theta(237))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                               &(theta(239)+theta(240))*dble(peduc_s(i))+theta(248)*awV(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+&
                               &epsilon_pSIMCE(2,i,sim)   
           else if (ctype.eq.3) then
             simca(i,ctype,sim)=beta0V(i)+theta(115)+(theta(242)+theta(244))*awV(mkt7_s(i))+(theta(236)+theta(238))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                               &(theta(239)+theta(241))*dble(peduc_s(i))+theta(248)*awV(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+&
                               &epsilon_pSIMCE(2,i,sim)
           end if    
      
         else 
         noevalSIMCE=1  !this is the case in which both SM and SV are equal to zero
         write(*,*) "Problem in sbroutine simulate_simce: did not find optimal choice for parents. family i,child type=", i,ctype
         write(*,*) "ucM=", ucM(ctype)
         write(*,*) "ucV=", ucV(ctype)
         write(*,*) "ucmax=", ucmax(ctype)
         write(*,*) "awM=", awM(mkt7_s(i))
         write(*,*) "awV=", awV(mkt7_s(i))
        ! read(*,*) stopping
     end if  


     if(zeroSM(mkt7_s(i)).eq.1.AND.zeroSV(mkt7_s(i)).eq.0) then !go to V
        simcM(i,ctype,sim)=0.0d0
        simcV(i,ctype,sim)=1.0d0
         !cognitive achievement in V = test scores
           if(ctype.eq.1) then
            
            simca(i,ctype,sim)=beta0V(i)+theta(242)*awV(mkt7_s(i))+theta(236)*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+theta(239)*dble(peduc_s(i))+&
                               &theta(248)*awV(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+&
                               &epsilon_pSIMCE(2,i,sim)
                              else if (ctype.eq.2) then
             simca(i,ctype,sim)=beta0V(i)+theta(114)+(theta(242)+theta(243))*awV(mkt7_s(i))+(theta(236)+theta(237))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                               &(theta(239)+theta(240))*dble(peduc_s(i))+theta(248)*awV(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+&
                               &epsilon_pSIMCE(2,i,sim)   
           else if (ctype.eq.3) then
             simca(i,ctype,sim)=beta0V(i)+theta(115)+(theta(242)+theta(244))*awV(mkt7_s(i))+(theta(236)+theta(238))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                               &(theta(239)+theta(241))*dble(peduc_s(i))+theta(248)*awV(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+&
                               &epsilon_pSIMCE(2,i,sim)
           end if    
    



     else if (zeroSM(mkt7_s(i)).ne.1.AND.zeroSV(mkt7_s(i)).eq.1) then !go to M
        simcM(i,ctype,sim)=1.0d0
        simcV(i,ctype,sim)=0.0d0

          !cognitive achievement in M = test scores
            if(ctype.eq.1) then
              simca(i,ctype,sim)=beta0M(i)+theta(116)*awM(mkt7_s(i))+theta(119)*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+theta(120)*dble(peduc_s(i))+&
                   &theta(196)*awM(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+epsilon_pSIMCE(1,i,sim)
            else if (ctype.eq.2) then
              simca(i,ctype,sim)=beta0M(i)+theta(111)+(theta(116)+theta(117))*awM(mkt7_s(i))+(theta(119)+theta(249))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                         & (theta(120)+theta(251))*dble(peduc_s(i))+&
                   &theta(196)*awM(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+epsilon_pSIMCE(1,i,sim) 
            else if (ctype.eq.3) then
              simca(i,ctype,sim)=beta0M(i)+theta(112)+(theta(116)+theta(118))*awM(mkt7_s(i))+(theta(119)+theta(250))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                   &(theta(120)+theta(252))*dble(peduc_s(i))+theta(196)*awM(mkt7_s(i))*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+epsilon_pSIMCE(1,i,sim)
            end if
     

     else if (zeroSM(mkt7_s(i)).eq.1.AND.zeroSV(mkt7_s(i)).eq.1) then !no outcome  !This will never be the case as I won't even get into this subroutine if this is the case
        noevalSIMCE=1
        simcM(i,ctype,sim)=-99.0d0
        simcV(i,ctype,sim)=-99.0d0
     end if

   end do !type 
  end do !sim
end do !i  




!Integrate out simulation number

simcaM_nosim=0.0d0; simcaV_nosim=0.0d0
simcasqM_nosim=0.0d0; simcasqV_nosim=0.0d0

simcV_nosim=0.0d0


SStarM=0.0d0; SStarV=0.0d0



 simcV_uncondSIMCE=0.0d0; simcaM_uncondSIMCE=0.0d0; simcaV_uncondSIMCE=0.0d0
 simcasqM_uncondSIMCE=0.0d0; simcasqV_uncondSIMCE=0.0d0

Psi(1)=(1.0d0-theta(127)-theta(128))
Psi(2)=theta(127)
Psi(3)=theta(128)

arbitrary_M=0; arbitrary_V=0

 sim_apv_nosim=0.0d0
 sim_sqapv_nosim=0.0d0


if(noevalSIMCE.ne.1) then

do i=1,n_s

 do ctype=1,NCType

  do sim=1,D

   simcV_nosim(i,ctype)=simcV_nosim(i,ctype)+simcV(i,ctype,sim)/dble(D)       
   simcaV_nosim(i,ctype)=simcaV_nosim(i,ctype)+simca(i,ctype,sim)*simcV(i,ctype,sim)/dble(D)
   simcasqV_nosim(i,ctype)=simcasqV_nosim(i,ctype)+(simca(i,ctype,sim)**2.0d0)*simcV(i,ctype,sim)/dble(D)
   
   simcaM_nosim(i,ctype)=simcaM_nosim(i,ctype)+simca(i,ctype,sim)*simcM(i,ctype,sim)/dble(D)
   simcasqM_nosim(i,ctype)=simcasqM_nosim(i,ctype)+(simca(i,ctype,sim)**2.0d0)*simcM(i,ctype,sim)/dble(D)

      sim_apv_nosim(i,ctype)=sim_apv_nosim(i,ctype)+pv_h(i)*simcV(i,ctype,sim)/dble(D)
     sim_sqapv_nosim(i,ctype)=sim_sqapv_nosim(i,ctype)+(pv_h(i)**2.0d0)*simcV(i,ctype,sim)/dble(D)


  
  end do !sim


  
end do !ctype

!Integrate out type

simcV_uncondSIMCE(i)=Psi(1)*simcV_nosim(i,1)+Psi(2)*simcV_nosim(i,2)+Psi(3)*simcV_nosim(i,3)
simcaV_uncondSIMCE(i)=Psi(1)*simcaV_nosim(i,1)+Psi(2)*simcaV_nosim(i,2)+Psi(3)*simcaV_nosim(i,3)
simcasqV_uncondSIMCE(i)=Psi(1)*simcasqV_nosim(i,1)+Psi(2)*simcasqV_nosim(i,2)+Psi(3)*simcasqV_nosim(i,3)

simcaM_uncondSIMCE(i)=Psi(1)*simcaM_nosim(i,1)+Psi(2)*simcaM_nosim(i,2)+Psi(3)*simcaM_nosim(i,3)
simcasqM_uncondSIMCE(i)=Psi(1)*simcasqM_nosim(i,1)+Psi(2)*simcasqM_nosim(i,2)+Psi(3)*simcasqM_nosim(i,3)

 sim_apv_uncond(i)=Psi(1)*sim_apv_nosim(i,1)+Psi(2)*sim_apv_nosim(i,2)+Psi(3)*sim_apv_nosim(i,3)
sim_sqapv_uncond(i)=Psi(1)*sim_sqapv_nosim(i,1)+Psi(2)*sim_sqapv_nosim(i,2)+Psi(3)*sim_sqapv_nosim(i,3)


end do !i
   
  
  
   


   

end if !noevalSIMCE

avg_simtsM=0.0d0; avg_simtsV=0.0d0






end subroutine simulate_simce2