      SUBROUTINE LUDCMP2(A,N,NP,INDX,D, Sing)

      REAL(8) A(NP,NP),VV(400),D,SUM,AAMAX,DUM
      REAL(8) TINY
      INTEGER Sing !=1 if singular
      INTEGER INDX(N),N,NP,IMAX,NMAX
      INTEGER I,J,K

      Sing=0
      NMAX = 400
      TINY = 1.0d-20 * 1.0d-0
      D=1.0d-0
      VV = 0.0d-0
      SUM = 0.0d-0

      DO 12 I=1,N
        AAMAX=0.0d-0
        DO 11 J=1,N
          IF (DABS(A(I,J)).GT.AAMAX) AAMAX=DABS(A(I,J))
11      CONTINUE
        IF (AAMAX.EQ.0.0d-0) Sing=1
        IF (AAMAX.EQ.0.0d-0) RETURN
        VV(I)=1./AAMAX
12    CONTINUE


      DO 19 J=1,N
        IF (J.GT.1) THEN
          DO 14 I=1,J-1
            SUM=A(I,J)
            IF (I.GT.1)THEN
              DO 13 K=1,I-1
                SUM=SUM-1.0d-0 *A(I,K)*A(K,J)
13            CONTINUE
              A(I,J)=SUM
            ENDIF
14        CONTINUE
        ENDIF
        AAMAX=0.0d-0
        DO 16 I=J,N
          SUM=A(I,J)
          IF (J.GT.1)THEN
            DO 15 K=1,J-1
              SUM=SUM-A(I,K)*A(K,J)
15          CONTINUE
            A(I,J)=SUM
          ENDIF
          DUM=VV(I)*DABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-1.*D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(J.NE.N)THEN
          IF(A(J,J).EQ.0.0d-0)A(J,J)=TINY
          DUM=1.0d-0/A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      IF(A(N,N).EQ.0.0d-0)A(N,N)=TINY
      RETURN
      END

!---------------------------------------------------------

      SUBROUTINE LUBKSB2(A,N,NP,INDX,B)

      REAL(8) A(NP,NP),B(N),SUM
      INTEGER INDX(N),N,NP,I,II,LL,J,K


      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        IF(I.LT.N)THEN
          DO 13 J=I+1,N
            SUM=SUM-A(I,J)*B(J)
13        CONTINUE
        ENDIF
        B(I)=SUM/A(I,I)
14    CONTINUE
      
      RETURN
      END

!----------------------------------
       subroutine dmatinv2(a,y,np,sing)
 
       integer np
       real(8) a(np,np),y(np,np),d,ac(np,np),b(np)
       integer indx(np),i,j,n, sing

       external LUDCMP2,LUBKSB2

!      make a copy of a so it will not be distroyed
!      and initialize y

       y = 0.0
       loop1: do i = 1,np
         ac(i,i) = a(i,i)
         y(i,i) = 1.0
       loop2: do j = 1,np
         ac(i,j) = a(i,j)
       end do loop2
       end do loop1
       indx(:)=0
       n = np

       call LUDCMP2(ac,np,np,indx,d, sing)
       if (sing==1) RETURN


       loop13: do j = 1,n
          call LUBKSB2(ac,n,np,indx,y(1,j))
       end do loop13

       return
       end subroutine dmatinv2

 
