# delimit ;
pause on;
set more off;
clear all;


infile inum id_s  sim weight mkt type primaria rural nfam peduc fem  mincome m v mtuition standability spv sV awM_sim awV_sim pv_used_minus_voucher voucher test_scoreM est_scoreV utility
using "simdata_simce_baseline_simulations_new.txt";

		
		
		
		 
		 sort id_s;
		 
		 
		 save simdata_simce_baseline, replace;
		 
		 
		* merge id_s using simdata_simce_baseline, keep(stsm_b stsv_b  spv_b sv_b awm_b awv_b p_onett_of_voucher  );
		* tab _m;
		* keep if _m==3;
		* drop _m;
		* sort id_s;
		 
		* gen sts_b=stsm_b if sv_b==0;
		* replace sts_b=stsv_b if sv_b==1;
		 
		 
		 
		* kdensity sts_b, addplot(kdensity sts_count, lp(dash));
		 
		* pause;
		 
		* gen stsM_b=stsm_b if sv_b==0;
		* gen stsV_b=stsv_b if sv_b==1;
		 
		* kdensity stsM_b, addplot(kdensity stsM_count);
		* pause;
		* kdensity stsV_b, addplot(kdensity stsV_count);
		 
** generate model fit graph:
 gen accepted_ts_M=test_scoreM if sV==0
  gen accepted_ts_V=test_scoreV if sV==1
  kdensity standability if m==1, addplot(kdensity accepted_ts_M)
graph save graph1, replace
kdensity standability if v==1, addplot(kdensity accepted_ts_V)
graph save graph2, replace
graph combine graph1.gph graph2.gph



  kdensity standability if m==1 & mkt==5, addplot(kdensity accepted_ts_M if mkt==5)
graph save graph1mkt5, replace
kdensity standability if v==1 & mkt==5, addplot(kdensity accepted_ts_V if mkt==5)
graph save graph2mkt5, replace
graph combine graph1mkt5.gph graph2mkt5.gph
