
* change directories below accordingly accordingly

cd "C:\Users\uctpm\Dropbox\projects\JMP\QE_revision\data and programs\Simulations - do files to analyze simulated data\counterfactuals\stata_files"
global stata_files="C:\Users\uctpm\Dropbox\projects\JMP\QE_revision\data and programs\Simulations - do files to analyze simulated data\counterfactuals\stata_files"


clear all
# delimit ;

 
 
 # delimit ;
 clear;
  infile  idnumber id sim weight mkt7 type_ref primaria rural  nfam peduc fem  mincome m  v  mtuition standability  spv_bonus sV_bonus awM_sim_bonus awV_sim_bonus
        pv_used_minus_voucher_bonus voucher_bonus test_scoreM_bonus test_scoreV_bonus utility_bonus using "$stata_files\bonus\simdata_simce_counterfactual_bonus.txt";

 sort id sim;
 * standardise utility with the baseline mean and standard deviation -- this way we calculate the impact in terms of standard deviations at baseline;
 gen utility_bonus_st=(utility_bonus-1.175829 )/ 3.417356;
 save simdata_simce_bonus, replace;
 clear;
 
 
 
 
 # delimit ;
 clear;
  infile  idnumber id sim weight mkt7 type_ref primaria rural  nfam peduc fem  mincome m  v  mtuition standability  spv_ref sV_ref awM_sim_ref awV_sim_ref
        pv_used_minus_voucher_ref voucher_ref test_scoreM_ref test_scoreV_ref utility_ref using "$stata_files\merit_reform\simdata_simce_counterfactual_RefEqm.txt";

 sort id sim;
 * standardise utility with the baseline mean and standard deviation -- this way we calculate the impact in terms of standard deviations at baseline;
 gen utility_ref_st=(utility_ref-1.175829 )/ 3.417356;
 sum utility_ref_st  if mincome<=1.5;
  sum utility_ref_st if mincome >1.5 & mincome !=.;
 save simdata_simce_merit_reform, replace;
 
 merge 1:1 idnumber using "$stata_files/simdata_simce_baseline_2017";

  drop _merge;
  

  

  
  save simdata_simce_merged, replace;

  
  
 clear;
 
   infile  idnumber id sim weight mkt7 type_ref primaria rural  nfam peduc fem  mincome m  v  mtuition standability  spv_ref_nop sV_ref_nop awM_sim_ref_nop awV_sim_ref_nop
        pv_used_minus_voucher_ref_nop voucher_ref_nop test_scoreM_ref_nop test_scoreV_ref_nop utility_ref_nop using 
		"$stata_files\merit_reform_no_parents_reaction\simdata_simce_counterfactual_RefEqm.txt";
 gen utility_ref_nop_st=(utility_ref_nop-1.175829 )/ 3.417356;
 sort id sim;
 
 save simdata_simce_merit_reform_no_parents, replace;
 
 
 clear;
 
   infile  idnumber id sim weight mkt7 type_ref primaria rural  nfam peduc fem  mincome m  v  mtuition standability  spv_ref_nov sV_ref_nov awM_sim_ref_nov awV_sim_ref_nov
        pv_used_minus_voucher_ref_nov voucher_ref_nov test_scoreM_ref_nov test_scoreV_ref_nov utility_ref_nov using 
		"$stata_files\merit_reform_noV\simdata_simce_counterfactual_RefEqm_no_V_reaction.txt";
 gen utility_ref_nov_st=(utility_ref_nov-1.175829 )/ 3.417356;;
 sort id sim;
 
 save simdata_simce_merit_reform_no_v, replace;
 
   clear;
   
   
     infile  idnumber id sim weight mkt7 type_ref primaria rural  nfam peduc fem  mincome m  v  mtuition standability  spv_com sV_com awM_sim_com awV_com
        pv_used_minus_voucher_com voucher_com test_scoreM_com test_scoreV_com utility_com using 
		"$stata_files\competency\simdata_simce_counterfactual_competency.txt";
 gen utility_com_st=(utility_com-1.175829 )/ 3.417356;;
 sort id sim;
 
 save simdata_simce_com, replace;
 
   clear;
   
   
   
   
   
   
 
****************************************************** WORKERS ****************************************************************************************
 ** open workers dataset;
 # delimit ;

		 
		 
		 		  # delimit ;
		 		 clear;
	infile id weight sim type mkt7 graddeg perfec nkids nkids2 nkids6 age fem
        peduc m_w v_w nt_w h_w wage swageM_bonus swageV_bonus swageNT_bonus  sM_bonus sV_bonus
        sNT_bonus sH_bonus stskills r_used_bonus utility_bonus using "$stata_files\bonus\simworkers_counterfactual_bonus.txt";
		
		sort id sim;
		gen saccepted_wage_bonus=swageM_bonus if sM_bonus==1;
		replace saccepted_wage_bonus=swageNT_bonus if sNT_bonus==1;
		replace saccepted_wage_bonus=swageV_bonus if sV_bonus==1;
		gen stskills_st=(stskills - 2.334733)/1.760315 ;
			gen occupation_bonus="H" if sH==1;
		replace occupation_bonus="M" if sM==1;
		replace occupation_bonus="V" if sV==1;
		replace occupation_bonus="NT" if sNT==1;
				gen utility_bonus_st=(utility_bonus -  180.0678    )/   609.9225   ;
		
		
			save simworkers_bonus, replace;
			
			clear;
			
			
			
		 
		  # delimit ;
		 		 clear;
	infile id weight sim type mkt7 graddeg perfec nkids nkids2 nkids6 age fem
        peduc m_w v_w nt_w h_w wage swageM_reform swageV_reform swageNT_reform  sM_ref sV_ref
        sNT_ref sH_ref stskills r_used_ref utility_ref using "$stata_files\merit_reform_no_parents_reaction\simworkers_counterfactual_RefEqm2_no_parents_reaction.txt";
		
		sort id sim;
		gen saccepted_wage=swageM_reform if sM_ref==1;
		replace saccepted_wage=swageNT_reform if sNT_ref==1;
		replace saccepted_wage=swageV_reform if sV_ref==1;
		gen stskills_st=(stskills - 2.334733)/1.760315 ;
			gen occupation_refnop="H" if sH==1;
		replace occupation_refnop="M" if sM==1;
		replace occupation_refnop="V" if sV==1;
		replace occupation_refnop="NT" if sNT==1;
		
		
			save simworkers_merit_reform_no_parents, replace;
			
			
					 		 clear;
	infile id weight sim type mkt7 graddeg perfec nkids nkids2 nkids6 age fem
        peduc m_w v_w nt_w h_w wage swageM_reform swageV_reform swageNT_reform  sM_ref sV_ref
        sNT_ref sH_ref stskills r_used_ref utility_ref using "$stata_files\merit_reform_noV\simworkers_counterfactual_RefEqm2_no_V_reaction.txt";
		
		sort id sim;
			gen saccepted_wage=swageM_reform if sM_ref==1;
		replace saccepted_wage=swageNT_reform if sNT_ref==1;
		replace saccepted_wage=swageV_reform if sV_ref==1;
		gen stskills_st=(stskills - 2.334733)/1.760315 ;
			gen occupation_refnov="H" if sH==1;
		replace occupation_refnov="M" if sM==1;
		replace occupation_refnov="V" if sV==1;
		replace occupation_refnov="NT" if sNT==1;
		
		
			save simworkers_merit_reform_no_v, replace;
			# delimit ;
							 		 clear;
  # delimit ;
		 clear;
	infile id weight sim type mkt7 graddeg perfec nkids nkids2 nkids6 age fem
        peduc m_w v_w nt_w h_w wage swageM_ref swageV_ref swageNT_ref  sM_ref sV_ref
        sNT_ref sH_ref stskills r_used_ref utility_ref using "$stata_files\merit_reform\simworkers_counterfactual_RefEqm2.txt";
		gen stskills_st=(stskills - 2.334733)/1.760315 ;
		sort id sim;
			gen saccepted_wage_ref=swageM_ref if sM_ref==1;
		replace saccepted_wage_ref=swageNT_ref if sNT_ref==1;
		replace saccepted_wage_ref=swageV_ref if sV_ref==1;
			save simworkers_merit_reform, replace;
			gen utility_st=(utility-   180.0678    )/   609.9225   ;
		gen utility_ref_st=(utility_ref -  180.0678    )/   609.9225   ;
			gen occupation_ref="H" if sH_ref==1;
		replace occupation_ref="M" if sM_ref==1;
		replace occupation_ref="V" if sV_ref==1;
		replace occupation_ref="NT" if sNT_ref==1;
		save simworkers_merit_reform, replace;
		clear;
		
		
		
		
								 		 clear;
  # delimit ;
		 clear;
	infile id weight sim type mkt7 graddeg perfec nkids nkids2 nkids6 age fem
        peduc m_w v_w nt_w h_w wage swageM_com swageV_com swageNT_com  sM_com sV_com
        sNT_com sH_com stskills r_used_com utility_com using "$stata_files\competency\simworkers_counterfactual_competency.txt";
		gen stskills_st=(stskills - 2.334733)/1.760315 ;
		sort id sim;
			gen saccepted_wage_com=swageM_com if sM_com==1;
		replace saccepted_wage_com=swageNT_com if sNT_com==1;
		replace saccepted_wage_com=swageV_com if sV_com==1;
			save simworkers_com, replace;
			gen utility_com_st=(utility_com -  180.0678    )/   609.9225   ;
			gen occupation_com="H" if sH_com==1;
		replace occupation_com="M" if sM_com==1;
		replace occupation_com="V" if sV_com==1;
		replace occupation_com="NT" if sNT_com==1;
		save simworkers_com, replace;
		clear;
		
		
		
		
		# delimit ;
		use simworkers_merit_reform;
		
		merge 1:1 id sim using "$stata_files/simworkers_baseline", keepusing(swageM swageV swageNT  sM sV
        sNT sH r_used utility);
		drop _merge;
		

		
		gen saccepted_wage=swageM if sM==1;
		replace saccepted_wage=swageNT if sNT==1;
		replace saccepted_wage=swageV if sV==1;
		
	
		
		gen weight_int=int(weight*100000000000);
		
		gen occupation_baseline="H" if sH==1;
		replace occupation_baseline="M" if sM==1;
		replace occupation_baseline="V" if sV==1;
		replace occupation_baseline="NT" if sNT==1;
		
		
		
	
		
		tab occupation_baseline occupation_ref [weight=weight_int ], row;
		
		merge 1:1 id sim using simworkers_bonus, keepusing(swageM_bonus swageV_bonus swageNT_bonus  sM_bonus sV_bonus
        sNT_bonus sH_bonus r_used_bonus utility_bonus_st);
		drop _merge;
		
		
			merge 1:1 id sim using simworkers_com, keepusing(swageM_com swageV_com swageNT_com  sM_com sV_com
        sNT_com sH_com r_used_com utility_com_st);
		drop _merge;
		
		save simworkers_merged, replace;
		
		* GENERATE FIGURE 3  IN THE PAPER
		

		* adding "& stskills_st>-2 " only to equalize the scale on the graphs -- in practice it doesn't change anything in the appearance of the graphs;
		kdensity stskills_st  if sM_ref ==1  [weight=weight_int ], bw(0.4) lpattern(solid) lwidth(medthick) 
		addplot(kdensity stskills_st  if sV_ref ==1 [weight=weight_int ], bw(0.4) lpattern(dash) lwidth(medthick) || 
		kdensity stskills_st  if sNT_ref ==1 [weight=weight_int ] , bw(0.4) lpattern("--..") lwidth(medthick))  
		legend(label(1 "Municipal") label(2 "Voucher") label(3 "Non-Teaching") ) title("2023 Reform")  xtitle("Teaching skills (standardized)")  xtick(-5(2)10) xline(0); 
		* xtick(0(5)20);
		
	graph save teaching_skills_counterfactual_merit_reform, replace;
	
	
	
	kdensity stskills_st  if sM_bonus ==1  [weight=weight_int ],   bw(0.4) lpattern(solid) lwidth(medthick) 
		addplot(kdensity stskills_st  if sV_bonus ==1  [weight=weight_int ],    bw(0.4) lpattern(dash) lwidth(medthick) || 
		kdensity stskills_st  if sNT_bonus ==1   [weight=weight_int ] ,    bw(0.4) lpattern("--..") lwidth(medthick) ) 
		legend(label(1 "Municipal") label(2 "Voucher") label(3 "Non-Teaching")   ) title("Flat bonus")  xtitle("Teaching skills (standardized)")  xtick(-5(2)10) xline(0); 
		* xtick(0(5)20);
			
		
	graph save teaching_skills_counterfactual_bonus, replace;
	
	
			 kdensity stskills_st  if sM ==1 [weight=weight_int ], bw(0.4) lpattern(solid) lwidth(medthick) 
		addplot(kdensity stskills_st  if sV ==1   [weight=weight_int ],   bw(0.4) lpattern(dash) lwidth(medthick) || 
		 kdensity stskills_st  if sNT ==1  [weight=weight_int ] ,   bw(0.4) lpattern("--..") lwidth(medthick) ) 
		legend(label(1 "Municipal") label(2 "Voucher") label(3 "Non-Teaching")   ) title("Baseline") xtitle("Teaching skills (standardized)") xtick(-5(2)10) xline(0) ;
		* xtick(0(5)20);
		
	graph save teaching_skills_baseline, replace;
	
			# delimit ;
		* adding "& stskills_st>-2 " only to equalize the scale on the graphs -- in practice it doesn't change anything in the appearance of the graphs;
		kdensity stskills_st  if sM_com ==1  [weight=weight_int ], bw(0.4) lpattern(solid) lwidth(medthick) 
		addplot(kdensity stskills_st  if sV_com ==1 [weight=weight_int ], bw(0.4) lpattern(dash) lwidth(medthick) || 
		kdensity stskills_st  if sNT_com ==1 [weight=weight_int ] , bw(0.4) lpattern("--..") lwidth(medthick)  )
		legend(label(1 "Municipal") label(2 "Voucher") label(3 "Non-Teaching")   ) title("Only competency")  xtitle("Teaching skills (standardized)")  xtick(-5(2)10) xline(0); 
		* xtick(0(5)20);
		
	graph save teaching_skills_counterfactual_com, replace;
	
	
	

	grc1leg teaching_skills_baseline.gph teaching_skills_counterfactual_merit_reform.gph teaching_skills_counterfactual_bonus.gph teaching_skills_counterfactual_com.gph, ycommon  position(4) ring(0);
	
	*title("Teaching skill distribution by occupational sector ")
	
	
	graph save combine_teaching_skills_merit_bonus_reforms, replace;
		
		
		
		
  
		
	
	
		clear;	
	
