MODULE VarDef
IMPLICIT NONE



    integer, parameter   :: p=304
    integer, parameter   :: NWType=3, NCType=3 !Number of types of workers and of kids
    
    real(8)              :: theta(p) , theta2(4) !vector of parameters

    real(8), parameter   :: cs_cap=100.0d0,p_cap=1.2+27391.903/100000.0d0   
                                                                     
    real(8), parameter   :: b=1.07d0 , voucher=27391.903/100000.0d0     
    real(8), parameter   :: voucher_prim=24856.88/100000.0d0, voucher_med=29926.925
	real(8), parameter   :: bonus=0.00d0 !  
    real(8), parameter    :: oneUSE=0.195d0 !in terms of 100k pesos     
    integer, parameter   :: D=1, Deld=100 !D determines the goodness of the approximation of profits, the higher the better the profits. It does not imply anything
                                           !on the sizes of the datasets to dowlonad 
    integer, parameter   :: Dpr=600 !number of shocks to the per-pupil cost, used to generate distribution of optimal prices p and r 300
                                    
    !Number of observations in profit interpolating regression
    integer, parameter   :: rnodes=40
    integer, parameter   :: pvnodes=40  
    integer, parameter   :: iter_num=1600  !iter_num=rnodes*pvnodes
   
   !Sample sizes
   !these are needed so that I can call just the size of the dat without having to call the data
    integer, parameter    :: n_mktvd=18 !number of markets used, common to all datasets
    integer, parameter    :: n_cpvd=21589, n_cwvd=3520 !number of primary and secondary students in casen_parents  
     integer, parameter   :: n_cp2vd=5000      
   integer, parameter     :: n_wvd=5471, n_svd=100000  
    
     real(8)              :: StartTime, EndTime, MidTime, BeginningTime
 real(8)                  :: epsilon_wglobal(4,n_wvd,D), epsilon_pglobal(3,n_svd,D), type_ipglobal(n_svd,D), type_iwglobal(n_wvd,D)
 real(8), parameter        :: rM_reform=1.4397666506634855270386 
     
    
    
    
    
    
    
    


END MODULE VarDef