

subroutine Interpolation(rM, Drep,l_lnr, u_lnr, l_p, u_p,outputname,Reg,ahatmat,Rsqmat,epsilon_p,epsilon_w,type_ip, type_iw, pv_omat, r_omat,positive_maxaprof,maxaprof_mat)
                       

                       
USE VarDef
USE MATRIX


IMPLICIT NONE

real(8), intent(in)         :: rM
integer, intent(in)         :: Drep
real(8), intent(in)         :: l_lnr, u_lnr, l_p, u_p
character(150), intent(in)  :: outputname
real(8), intent(in)         :: Reg(1:iter_num,1:10)
real(8), intent(out)        :: ahatmat(10,n_mktvd,Drep),Rsqmat(n_mktvd,Drep) 
real(8), intent(in)         :: epsilon_p(3,n_svd,D), epsilon_w(4,n_wvd,D), type_ip(n_svd,D), type_iw(n_wvd,D)

real(8), intent(out)        :: pv_omat(n_mktvd, Drep), r_omat(n_mktvd,Drep), positive_maxaprof(n_mktvd,Drep), maxaprof_mat(n_mktvd,Drep)

integer                     :: noeval, indicator

character(30)               :: prefix,suffix, outputname2, txt



real(8)                       ::  pv, ln_r  !use the same evaluation point pv, lm_r in all mkts

real(8)                       :: shock_cost_stand(Drep), shock_cost(Drep), shock_cost_iter

integer                       :: i, mkt, stopping, idum, sim, iter, iter_r, iter_pv, sim_cost, k, kk, errinv, ii

integer                       :: num_eval(n_mktvd, Drep)  !number of evaluation points used in each market and cost shock draw. I keep only non-negative profits

real(8), dimension(n_mktvd)   :: awV, awM, SV, TSV
real(8), dimension(n_mktvd)   :: zeroSM, zeroSV
real(8), dimension(n_mktvd)   :: DV, EPV


real(8), dimension(iter_num,n_mktvd) :: DVmat, EPVmat, TSVmat, SVmat 

real(8)                       :: unit_revenue(iter_num,n_mktvd,Drep), unit_fellow(iter_num,n_mktvd,Drep), profitmat(iter_num,n_mktvd,Drep)

real(8)                       :: XpYprof(10), ybar, RSS, TSS
real(8)                       :: XpX(10,10), XpX_inv(10,10)  
real(8), allocatable          :: Yprof_hat(:)  !It will have a size equal to the number of evaluation points i.e. nonmissing profits
real(8)                       :: checkreg(10,10) 
integer                       :: SINGULAR
integer                       :: use_draw(n_mktvd,Drep)



!Used by constrained profit maximizaton routine
real(8)                       :: ahat(10)
real(8)                       :: p_o, r_o, lambda_o ,  maximized_aprofits

integer                       :: print_profits



!write(*,*) "Inside interpolation, Drep=", Drep
errinv=0

use_draw=1
num_eval=0

pv_omat=-991.0d0
r_omat=-991.0d0

noeval=0
ahatmat=0.0d0; Rsqmat=-99.0d0; profitmat=-99.0d0

positive_maxaprof=-99.0d0; maxaprof_mat=-99.0d0


!######## Draw cost shocks ############

idum=773
call gasdev(idum, shock_cost_stand,Drep)





print_profits=0
if (print_profits.eq.1) then

  prefix='simulated_profits_'
  indicator=int(rM*10)

 



if(indicator.eq.1) then
      open(unit=6565,file='./simprofits_countEqmRef_1.txt') !file where I print the simulate profits dto double check regressions
else if (indicator.eq.2) then
      open(unit=6565,file='./simprofits_countEqmRef_2.txt') !file where I print the simulate profits dto double check regressions
else if (indicator.eq.3) then
      open(unit=6565,file='./simprofits_countEqmRef_3.txt') !file where I print the simulate profits dto double check regressions
else if (indicator.eq.4) then
      open(unit=6565,file='./simprofits_countEqmRef_4.txt') !file where I print the simulate profits dto double check regressions
else if (indicator.eq.5) then
      open(unit=6565,file='./simprofits_countEqmRef_5.txt') !file where I print the simulate profits dto double check regressions
else if (indicator.eq.6) then
      open(unit=6565,file='./simprofits_countEqmRef_6.txt') !file where I print the simulate profits dto double check regressions
else if (indicator.eq.7) then
      open(unit=6565,file='./simprofits_countEqmRef_7.txt') !file where I print the simulate profits dto double check regressions
else if (indicator.eq.8) then
      open(unit=6565,file='./simprofits_countEqmRef_8.txt') !file where I print the simulate profits dto double check regressions
else if (indicator.eq.9) then
      open(unit=6565,file='./simprofits_countEqmRef_9.txt') !file where I print the simulate profits dto double check regressions
else if (indicator.eq.10) then
      open(unit=6565,file='./simprofits_countEqmRef_10.txt') !file where I print the simulate profits dto double check regressions
end if
  





end if !print_profits

iter=0

do iter_r=1,rnodes
 do iter_pv=1,pvnodes
   iter=iter+1

         pv=(cos(((2.0d0*dble(iter_pv)-1.0d0)/(2.0d0*dble(pvnodes)))*3.14159265))*((u_p-l_p)/2.0d0)+0.5d0*(u_p+l_p+2.0d0*27391.903/100000.0d0)            !If you change this, change it also in subroutine interpolation
         ln_r=(cos(((2.0d0*dble(iter_r)-1.0d0)/(2.0d0*dble(rnodes)))*3.14159265))*((u_lnr-l_lnr)/2.0d0)+0.5d0*(u_lnr+l_lnr)
      !The cost shock has NO EFFECT on DV, Totskills_wV and awV

      ! ##### Given current iteration for rate (the same for all markets), compute supply of teachers, supply of teaching skills and average taching skills
      !       in all markets. Output also a dummy for whether at that price there is zero supply to M or to V, in each market

      call simulate_workers(rM, ln_r,epsilon_w, type_iw,awV, awM, SV, TSV, zeroSM, zeroSV ) 

      ! ##### Given current iteration for price (the same for all markets) and given the current teaching abilities, compute demand for enrollment and average price paid
      !       in all markets. If for a certain market there are zero teachers in both schools at that value: assume that DV=0, and assign  alow value to profits (zero?)
      !      so that it will never want to pick that value at the optimum 

      call simulate_parents(pv, zeroSM, zeroSV, awM,awV,epsilon_p, type_ip, DV, EPV )

    ! write(*,*) "CLass size mkt1", DV(1)/SV(1)
    !Fill in a matrix with: DV, EPV, TSV, SV in all markets and at all evaluation points
     
    do mkt=1, n_mktvd
      DVmat(iter,mkt)=DV(mkt)
      EPVmat(iter,mkt)=EPV(mkt)
      TSVmat(iter,mkt)=TSV(mkt)
      SVmat(iter,mkt)=SV(mkt)

     !## Conditional on being in a certain markte, start loop over cost shock
     !## Interpolate profits inside the cost shock loop

     do sim_cost=1,Drep
        shock_cost(sim_cost)=exp( exp(theta2(1))*shock_cost_stand(sim_cost)  )/100.0d0  !the cost is lognormal, so I have to take the exp of the normal draw 
                                                                                      !I dividfe by two ootherwise the cost shock is too high. This is like a change in units. innocuous
        shock_cost_iter=shock_cost(sim_cost)

        if(iter.eq.1.AND.mkt.eq.1) then
          !write(*,*) "cost shock, sim_c", shock_cost(sim_cost), sim_cost
        end if

        if(DV(mkt).ne.0.0d0.AND.SV(mkt).ne.0.0d0) then
           !write profit function using actual governmental formulas
           if(0.50d0*oneUSE<EPVmat(iter,mkt).le.oneUSE) then
              unit_revenue(iter,mkt,sim_cost)=Reg(iter,2)-0.10d0*(EPVmat(iter,mkt)-0.50d0*oneUSE)
           else if (oneUSE<EPVmat(iter,mkt).le.2.0d0*oneUSE) then
              unit_revenue(iter,mkt,sim_cost)=Reg(iter,2)-0.10d0*0.50d0*oneUSE-0.20d0*(EPVmat(iter,mkt)-oneUSE)
           else if (2.0d0*oneUSE<EPVmat(iter,mkt))  then
              unit_revenue(iter,mkt,sim_cost)=Reg(iter,2)-0.10d0*0.50d0*oneUSE-0.20d0*oneUSE-0.350d0*(EPVmat(iter,mkt)-2.0d0*oneUSE)
           end if 
        
           if(EPVmat(iter,mkt).le.oneUSE) then
             unit_fellow(iter,mkt,sim_cost)=0.050d0*EPVmat(iter,mkt)
           else if (oneUSE<EPVmat(iter,mkt).le.2.0d0*oneUSE) then
             unit_fellow(iter,mkt,sim_cost)=0.050d0*oneUSE+0.070d0*(EPVmat(iter,mkt)-oneUSE)
           else if(2.0d0*oneUSE<EPVmat(iter,mkt)) then
             unit_fellow(iter,mkt,sim_cost)=0.050d0*oneUSE+0.070d0*oneUSE+0.10d0*(EPVmat(iter,mkt)-2.0d0*oneUSE)
           end if

        profitmat(iter,mkt,sim_cost)=(unit_revenue(iter,mkt,sim_cost)-unit_fellow(iter,mkt,sim_cost))*DV(mkt)-(theta2(2)+shock_cost_iter)*DV(mkt)-theta2(3)*DV(mkt)**2.0d0&
                                   &-(exp(ln_r)*TSV(mkt))-theta2(4)*((DV(mkt)/SV(mkt))/45.0d0)
  
             if(profitmat(iter,mkt,sim_cost)>0.0d0) then
               num_eval(mkt,sim_cost)=num_eval(mkt,sim_cost)+1
             else
                   profitmat(iter,mkt,sim_cost)=-99.0d0
             end if

            
        else
    
          profitmat(iter,mkt,sim_cost)=-99.0d0  

       end if !DV=0 and SV=0

        



!####  write to file a dataset with the profits in eac hmarket and for each cost shock :: I will show these graphs!

        if(sim_cost==1.AND.print_profits.eq.1) then
         open(unit=6565,file='./simprofits_count1b.txt')
       if(profitmat(iter,mkt,sim_cost).ne.-99.0d0) then
        write(6565,*) iter, mkt, sim_cost, profitmat(iter,mkt,sim_cost),pv, ln_r,  DVmat(iter,mkt), EPVmat(iter,mkt), SVmat(iter,mkt), TSVmat(iter,mkt), &
                    & unit_revenue(iter,mkt,sim_cost), unit_fellow(iter,mkt,sim_cost), theta2(2), shock_cost_iter, theta2(3), theta2(4)
       end if
	   close(6565)

      end if !sim_cost


     end do !sim cost

   end do !mkt


        


 end do !iter_pv
end do  !iter_ln





    

do sim_cost=1,Drep
   do mkt=1,n_mktvd
   
   if(num_eval(mkt,sim_cost)<1) then

   use_draw(mkt,sim_cost)=0

    !open(unit=9019, file=diagnostics)
    !  write(9019,*) "ERROR: zero obervations with positive profits"
    !close(9019)

   ! write(*,*) "ERROR: zero observations with positive profits. mkt, sim_cost", mkt, sim_cost
   
  else

   allocate(Yprof_hat(num_eval(mkt,sim_cost)))
 
   XpYprof=0.00
     do k=1,10 !9 regressors + 1 constant =10
      do i=1, iter_num  !num_eval(mkt,sim_cost)
       if(profitmat(i,mkt,sim_cost).ne.-99.0d0) then
        XpYprof(k)=XpYprof(k)+Reg(i,k)*profitmat(i,mkt,sim_cost) 
       end if    
      end do !i
     end do !k

!Compute XpX_inv

!Compute XpX and XpX_inv used in all regressions
XpX=0.00d0
 
  
  do kk=1,10
   do k=1,10 !9 regressors + 1 constant =10
    do i=1, iter_num !num_eval(mkt,sim_cost)
       if(profitmat(i,mkt,sim_cost).ne.-99.0d0) then
           XpX(k,kk)=XpX(k,kk)+Reg(i,k)*Reg(i,kk)

       end if
   end do !i
  end do !k
 end do !kk
 
 
XpX_inv=XpX !initializing

XpX_inv=MATINV(XpX)

!call matrix_inverse(XpX,XpX_inv)
!SINGULAR=0
!call  dmatinv2(XpX,XpX_inv,10,SINGULAR)  !first is matrix to be inverted, second is matrix that is inverted


!write(*,*) "Checking that inverse computed correctly"


checkreg=0.00
do kk=1,10
   do k=1,10 !9 regressors + 1 constant = 10 
  do i=1,10
    checkreg(k,kk)=checkreg(k,kk)+XpX_inv(k,i)*XpX(i,kk) 
   end do
  end do !k
 end do !kk
 
 
 do kk=1,10
  do k=1,10
    if(k==kk.AND.(checkreg(k,kk)<0.999.OR.checkreg(k,kk)>1.001)) then
   !  write(*,*) "ERROR while inverting XpX for csV and profit approximation"
   !  write(*,*) "Diagonal element not close enough to 1.0=", checkreg(k,kk)
   !  write(*,*) "number of obs used", num_eval(mkt,sim_cost)
   !  write(*,*) "mkt, sim_cost", mkt, sim_cost
    ! write(*,*) "XpX row by row"
    ! write(*,*) "Row 1:", XpX(1,1:10)
    ! write(*,*) "Row 2:", XpX(2,1:10)
    ! write(*,*) "Row 3:", XpX(3,1:10)
    ! write(*,*) "Row 4:", XpX(4,1:10)
    ! write(*,*) "Row 5:", XpX(5,1:10)
    ! write(*,*) "Row 6:", XpX(6,1:10)
     errinv=1
        !  read(*,*) stopping
    else if(k.ne.kk.AND.(checkreg(k,kk)<-0.001.OR.checkreg(k,kk)>0.001)) then
    ! write(*,*) "ERROR while inverting matrix XpX for csV and profit approximation"
    ! write(*,*) "Off-diagonal element=", checkreg(k,kk)
    ! write(*,*) "number of obs used", num_eval(mkt,sim_cost)
    ! write(*,*) "mkt, sim_cost", mkt, sim_cost
    ! write(*,*) "XpX row by row"
    ! write(*,*) "Row 1:", XpX(1,1:10)
    ! write(*,*) "Row 2:", XpX(2,1:10)
    ! write(*,*) "Row 3:", XpX(3,1:10)
    ! write(*,*) "Row 4:", XpX(4,1:10)
    ! write(*,*) "Row 5:", XpX(5,1:10)
    ! write(*,*) "Row 6:", XpX(6,1:10)
    errinv=1
     !read(*,*) stopping
    end if
  end do
 end do 


 if(errinv.eq.1) then
    ! write(*,*) "Error inverting regressors used in interpolation"
    open(unit=9009, file='./diagnostics_inverse_count1')
      write(9009,*) "Cannot properly invert regressors for interpolation"
      write(*,*) "Cannot properly invert regressors for interpolation, sim_cost, mkt=", sim_cost, mkt
    close(9009)
 end if




    ahatmat(1:10,mkt,sim_cost)=0.0d0
    ahat=0.0d0
 
    do k=1,10
      do kk=1,10
       ahatmat(k,mkt,sim_cost)=ahatmat(k,mkt,sim_cost)+XpX_inv(k,kk)*XpYprof(kk)
       ahat(k)=ahat(k)+XpX_inv(k,kk)*XpYprof(kk)
      end do !kk
    end do !k
   
  

    !compute fitted values
    ybar=0.00; RSS=0.00; TSS=0.00
    Yprof_hat=0.00
    ii=0
    do i=1, iter_num !num_eval(mkt,sim_cost)
       if(profitmat(i,mkt,sim_cost)>0) then 
         ii=ii+1
           do k=1,10
            Yprof_hat(ii)=Yprof_hat(ii)+ahatmat(k,mkt,sim_cost)*Reg(ii,k)
           end do !kk loop 
            ybar=ybar+profitmat(ii,mkt,sim_cost)
            RSS=RSS+(profitmat(ii,mkt,sim_cost)-Yprof_hat(ii))**2
        end if !that selects only non missing profits
    end do
    ybar=ybar/(dble(num_eval(mkt,sim_cost)))

    deallocate(Yprof_hat)

    RSS=RSS/(dble(num_eval(mkt,sim_cost)))

   do i=1,iter_num !num_eval(mkt,sim_cost)
     if(profitmat(i,mkt,sim_cost)>0) then 
         TSS=TSS+(profitmat(i,mkt,sim_cost)-ybar)**2
      end if
    end do
    TSS=TSS/(dble(num_eval(mkt,sim_cost)))

    Rsqmat(mkt,sim_cost)=1.00d0-RSS/TSS
   ! write(*,*) "mkt, cost shock", mkt, sim_cost
   ! write(*,*) "R squared", Rsqmat(mkt,sim_cost)

  if(mkt.eq.1.AND.sim_cost.eq.1) then
    write(*,*) ""
    write(*,*) "mkt, sim_cost=",mkt, sim_cost
    write(*,*) "Value of cost shock", shock_cost(sim_cost)
    write(*,*) "Estimated coefficients in profit approximation, sim_cost 1 and mkt 1"
    write(*,*) ahatmat(2,mkt,sim_cost), "pV"
    write(*,*) ahatmat(3,mkt,sim_cost), "pV**2"
    write(*,*) ahatmat(4,mkt,sim_cost), "r"
    write(*,*) ahatmat(5,mkt,sim_cost), "r**2"
    write(*,*) ahatmat(6,mkt,sim_cost), "pV*r"
    write(*,*) ahatmat(7,mkt,sim_cost), "pV**3"
    write(*,*) ahatmat(8,mkt,sim_cost), "r**3"
    write(*,*) ahatmat(9,mkt,sim_cost), "pV**2 *r"
    write(*,*) ahatmat(10,mkt,sim_cost), "pV* r**2"
    write(*,*) ahatmat(1,mkt,sim_cost), "const" 
   write(*,*) "R squared",  Rsqmat(mkt,sim_cost)

    write(*,*) ""
   end if





!############ Stay within the market and cost shock draw, and compute the optimal tuition and wage rates ################


   call constr_maxprof(ahat, p_o, r_o, lambda_o,u_p, l_p, u_lnr, l_lnr, maximized_aprofits)


  !  if(mkt.eq.15) then
  !   write(*,*) ""
  !   write(*,*) "mkt 15, sim=", sim_cost
  !  end if
  ! call max_at_cap(ahat, p_o, r_o, maximized_aprofits)

   pv_omat(mkt,sim_cost)=p_o
   r_omat(mkt,sim_cost)=r_o
  if(maximized_aprofits>0.0d0) then
   positive_maxaprof(mkt,sim_cost)=1.0d0
   maxaprof_mat(mkt,sim_cost)=maximized_aprofits

     else
       positive_maxaprof(mkt,sim_cost)=0.0d0
    maxaprof_mat(mkt,sim_cost)=maximized_aprofits
  end if



     end if !that selects out the case in which there are zero observations with nonmissing profits. profits missing iff zeroSV=1 or zeroDV=1 


   if(pv_omat(mkt,sim_cost)>0.0d0.AND.maxaprof_mat(mkt,sim_cost)<0.0d0) then
      write(*,*) "WARNING: inside interplation1, positive optimal price but negative profits in mkt, cost shock", mkt, sim_cost ! maxaprof_mat(mkt,sim_cost)
   end if
   end do !mkt
end do !cost shock




!write(*,*) "Computed optimal prices by market and shock"
!write(*,*) "mkt, sim, pv_o, r_o"




end subroutine Interpolation
