subroutine simdata_workers2_gvmt(rM_int,iter_rM,outcomes0,outcomes1,outcomes05,case,entry,rM, r_used, awM_sim, awV_sim, zeroSM_sim, zeroSV_sim,TotwagesM, SupV, TSV)
                                
                              
USE VarDef
USE Datasets
IMPLICIT NONE



integer, intent(in)    :: case, iter_rM, rM_int
real(8), intent(in)    :: entry(n_mktvd), rM                                          
real(8), intent(in)    :: r_used(n_mkt)
real(8), intent(out)   ::  awM_sim(n_mkt), awV_sim(n_mkt), zeroSM_sim(n_mkt), zeroSV_sim(n_mkt)
real(8), intent(out)   :: TotwagesM(n_mkt), SupV(n_mkt), TSV(n_mkt)
real(8), intent(inout)  :: outcomes0(0:iter_rM,10),outcomes1(0:iter_rM,10),outcomes05(0:iter_rM,10)

real(8)                :: epsilon_w(4,n_w,D) , epsilon_wvec(4*n_w*D)

real(8)                ::  swagesqNT(n_w,D),  swagesqM(n_w,D), swagesqV(n_w,D)
real(8)                :: constM(NWType), constNT(NWType),lnwageM(n_w,D), lnwageV(n_w,D), lnwageNT(n_w,D), uwM, uwV, uwNT, uwH
real(8)                :: umax, ln_r
integer                :: i, sim, mkt, wtype, cat, stopping, idum
integer                :: type_i(n_w,D)
real(8)                :: unif(n_w*D)

!simulated datasets
integer                :: sM(n_w,D), sV(n_w,D), sNT(n_w,D), sH(n_w,D)  
real(8)                :: swageM(n_w,D), swageV(n_w,D), swageNT(n_w,D) , stskills(n_w,D)  ,  utility_work(n_w,D)


!Variables needed to compute average ability of teachers
real(8), dimension(n_mktvd)    :: SM_sim, SV_sim, TSV_sim



real(8)                :: Psi(NWType), Pr1, Pr2, Pr3

real(8)               :: abilityM, abilityV, abilityT, tsm2, tsv2, tst2


real(8)                :: optimal_rv(18), rate_M, implied_rm(18)
integer                 :: print_dataset

!list of id's of people who chose M school in baseline scneario (simulations)
integer                :: old_M_teacher(n_w,D)

write(*,*) "Inside simdata_workers1b.f90"
old_M_teacher=-99


utility_work=-99.0d0



type_i=-99
unif=-99.0d0




sM=0.0d0; sV=0.0d0; sNT=0.0d0; sH=0.0d0
swageM=0.0d0; swageV=0.0d0; swageNT=0.0d0; swagesqM=0.0d0; swagesqV=0.0d0; swagesqNT=0.0d0

abilityM=0.0d0; abilityV=0.0d0; abilityT=0.0d0

write(*,*) "about to open M_teachers_baseline.txt file"
open(unit=565,file='./M_teachers_baseline.txt')
do i=1,n_w
 do sim=1,D
read(565,*) old_M_teacher(i,sim)
 end do
end do
close(565)
write(*,*) "finished reading M_teachers_baseline.txt"

open(unit=45,file='./implied_rm.txt')

  do mkt=1,18
    read(45,*) implied_rm(mkt)
  end do

close(45)






!Draw one type draw for each individual
Psi(1)=1.0d0-theta(92)-theta(93)
Psi(2)=theta(92)
Psi(3)=theta(93)



!!use same shocks as in baseline
open(unit=878571,file='./baseline_shocks_workers.txt')
  do i=1,n_w
    do sim=1,D
	 
	   read(878571,*) epsilon_w(1,i,sim), epsilon_w(2,i,sim), epsilon_w(3,i,sim), epsilon_w(4,i,sim), type_i(i,sim)


    end do
  end do

close(878571)



do i=1,n_w

    mkt=mkt7_w(i)

    rate_M=(rM)    !*implied_rm(mkt) !+rM*implied_rm(mkt)/10.0d0 NB: must change this also in the negprof routine!!!
     
    !NT: notice: they vary by worker's type, NB: constNT=ability constant. ln_r=log of wage
    if(mkt.eq.1) then
     constNT(1)=theta(18)
     constNT(2)=theta(18)+theta(36)
     constNT(3)=theta(18)+theta(54)
     constM(1)=theta(1)
     constM(2)=theta(1)+theta(2)
     constM(3)=theta(1)+theta(3)
    ! ln_r=0.10d0

    else if (mkt.eq.2) then
    constNT(1)=theta(19)
    constNT(2)=theta(19)+theta(37)
    constNT(3)=theta(19)+theta(55)
   ! ln_r=theta(177)
     constM(1)=theta(288)
     constM(2)=theta(288)+theta(2)
     constM(3)=theta(288)+theta(3)

    else if (mkt.eq.3) then
    constNT(1)=theta(20)
    constNT(2)=theta(20)+theta(38)
    constNT(3)=theta(20)+theta(56)
   ! ln_r=theta(178)
     constM(1)=theta(289)
     constM(2)=theta(289)+theta(2)
     constM(3)=theta(289)+theta(3)

     else if (mkt.eq.4) then
    constNT(1)=theta(21)
    constNT(2)=theta(21)+theta(39)
    constNT(3)=theta(21)+theta(57)
   ! ln_r=theta(179)
     constM(1)=theta(290)
     constM(2)=theta(290)+theta(2)
     constM(3)=theta(290)+theta(3)

     else if (mkt.eq.5) then
    constNT(1)=theta(22)
    constNT(2)=theta(22)+theta(40)
    constNT(3)=theta(22)+theta(58)
   ! ln_r=theta(180)
     constM(1)=theta(291)
     constM(2)=theta(291)+theta(2)
     constM(3)=theta(291)+theta(3)

    else if (mkt.eq.6) then
    constNT(1)=theta(23)
    constNT(2)=theta(23)+theta(41)
    constNT(3)=theta(23)+theta(59)
   ! ln_r=theta(181)
     constM(1)=theta(292)
     constM(2)=theta(292)+theta(2)
     constM(3)=theta(292)+theta(3)

    else if (mkt.eq.7) then
    constNT(1)=theta(24)
    constNT(2)=theta(24)+theta(42)
    constNT(3)=theta(24)+theta(60)
   ! ln_r=theta(182)
     constM(1)=theta(293)
     constM(2)=theta(293)+theta(2)
     constM(3)=theta(293)+theta(3)

    else if (mkt.eq.8) then
    constNT(1)=theta(25)
    constNT(2)=theta(25)+theta(43)
    constNT(3)=theta(25)+theta(61)
    !ln_r=theta(183)
     constM(1)=theta(294)
     constM(2)=theta(294)+theta(2)
     constM(3)=theta(294)+theta(3)

    else if (mkt.eq.9) then
    constNT(1)=theta(26)
    constNT(2)=theta(26)+theta(44)
    constNT(3)=theta(26)+theta(62)   
   ! ln_r=theta(184)
     constM(1)=theta(295)
     constM(2)=theta(295)+theta(2)
     constM(3)=theta(295)+theta(3)

    else if (mkt.eq.10) then
    constNT(1)=theta(27)
    constNT(2)=theta(27)+theta(45)
    constNT(3)=theta(27)+theta(63)
    !ln_r=theta(185)
     constM(1)=theta(296)
     constM(2)=theta(296)+theta(2)
     constM(3)=theta(296)+theta(3)

    else if (mkt.eq.11) then
    constNT(1)=theta(28)
    constNT(2)=theta(28)+theta(46)
    constNT(3)=theta(28)+theta(64)
   ! ln_r=theta(186)
     constM(1)=theta(297)
     constM(2)=theta(297)+theta(2)
     constM(3)=theta(297)+theta(3)

    else if (mkt.eq.12) then
    constNT(1)=theta(29)
    constNT(2)=theta(29)+theta(47)
    constNT(3)=theta(29)+theta(65)
   ! ln_r=theta(187)
     constM(1)=theta(298)
     constM(2)=theta(298)+theta(2)
     constM(3)=theta(298)+theta(3)

    else if (mkt.eq.13) then
    constNT(1)=theta(30)
    constNT(2)=theta(30)+theta(48)
    constNT(3)=theta(30)+theta(66)
  !  ln_r=theta(188)
     constM(1)=theta(299)
     constM(2)=theta(299)+theta(2)
     constM(3)=theta(299)+theta(3)

    else if (mkt.eq.14) then
    constNT(1)=theta(31)
    constNT(2)=theta(31)+theta(49)
    constNT(3)=theta(31)+theta(67)
   ! ln_r=theta(189)
     constM(1)=theta(300)
     constM(2)=theta(300)+theta(2)
     constM(3)=theta(300)+theta(3)

    else if (mkt.eq.15) then
    constNT(1)=theta(32)
    constNT(2)=theta(32)+theta(50)
    constNT(3)=theta(32)+theta(68)
  !  ln_r=theta(190)
     constM(1)=theta(301)
     constM(2)=theta(301)+theta(2)
     constM(3)=theta(301)+theta(3)

    else if (mkt.eq.16) then
    constNT(1)=theta(33)
    constNT(2)=theta(33)+theta(51)
    constNT(3)=theta(33)+theta(69)
  !  ln_r=theta(191)
     constM(1)=theta(302)
     constM(2)=theta(302)+theta(2)
     constM(3)=theta(302)+theta(3)

    else if (mkt.eq.17) then
    constNT(1)=theta(34)
    constNT(2)=theta(34)+theta(52)
    constNT(3)=theta(34)+theta(70)
   ! ln_r=theta(192)
     constM(1)=theta(303)
     constM(2)=theta(303)+theta(2)
     constM(3)=theta(303)+theta(3)

    else if (mkt.eq.18) then
    constNT(1)=theta(35)
    constNT(2)=theta(35)+theta(53)
    constNT(3)=theta(35)+theta(71)
  !  ln_r=theta(193)
     constM(1)=theta(304)
     constM(2)=theta(304)+theta(2)
     constM(3)=theta(304)+theta(3)

    end if
  

    ln_r=log(r_used(mkt7_w(i)))  !since the wage is positive in all markets, it will be positive also in the mkt in which i resides
  

   do sim=1,D

  if(type_i(i,sim).eq.1) then
   
  stskills(i,sim)=exp(theta(10)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+&
                    & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim))


   lnwageM(i,sim)=constM(1)+theta(5)*dble(age_w(i))+theta(6)*(dble(age_w(i))**2.0d0)+theta(7)*dble(fem_w(i))+theta(8)*dble(perfec_w(i))+&
                  & theta(9)*dble(graddeg_w(i))+epsilon_w(2,i,sim)+bonus 
  lnwageV(i,sim) =ln_r+theta(10)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+&
                    & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim)
  lnwageNT(i,sim)=constNT(1)+theta(72)*dble(age_w(i))+theta(73)*(dble(age_w(i))**2.0d0)+theta(74)*dble(fem_w(i))+theta(75)*dble(perfec_w(i))+&
                   & theta(76)*dble(graddeg_w(i))+epsilon_w(4,i,sim)
  uwM=lnwageM(i,sim)+theta(77)+theta(287)*dble(fem_w(i))
  uwV=lnwageV(i,sim)+theta(80)+theta(287)*dble(fem_w(i))
  uwNT=lnwageNT(i,sim)
  uwH=theta(83)+theta(86)*dble(fem_w(i))+theta(87)*dble(fem_w(i))*dble(nkids_w(i))+theta(88)*dble(age_w(i))+theta(194)*(dble(age_w(i)))**2.0d0+&
         & theta(89)*dble(nkids_w(i))+theta(90)*dble(nkids2_w(i))+&
         & theta(91)*(dble(nkids6_w(i))-dble(nkids2_w(i)))+epsilon_w(1,i,sim)


  else if (type_i(i,sim).eq.2) then

  stskills(i,sim)=exp(theta(10)+theta(11)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+&
                    & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim))
 
 lnwageM(i,sim)=constM(2)+theta(5)*dble(age_w(i))+theta(6)*(dble(age_w(i))**2.0d0)+theta(7)*dble(fem_w(i))+theta(8)*dble(perfec_w(i))+&
                    & theta(9)*dble(graddeg_w(i))+epsilon_w(2,i,sim)+bonus 
  lnwageV(i,sim) =ln_r+theta(10)+theta(11)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+&
                    & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim)
  lnwageNT(i,sim)=constNT(2)+theta(72)*dble(age_w(i))+theta(73)*(dble(age_w(i))**2.0d0)+theta(74)*dble(fem_w(i))+theta(75)*dble(perfec_w(i))+&
                   & theta(76)*dble(graddeg_w(i))+epsilon_w(4,i,sim)
  uwM=lnwageM(i,sim)+theta(77)+theta(78)+theta(287)*dble(fem_w(i))
  uwV=lnwageV(i,sim)+theta(80)+theta(81)+theta(287)*dble(fem_w(i))
  uwNT=lnwageNT(i,sim)
  uwH=theta(83)+theta(84)+theta(86)*dble(fem_w(i))+theta(87)*dble(fem_w(i))*dble(nkids_w(i))+theta(88)*dble(age_w(i))+&
         & theta(194)*(dble(age_w(i)))**2.0d0+theta(89)*dble(nkids_w(i))+theta(90)*dble(nkids2_w(i))+&
         & theta(91)*(dble(nkids6_w(i))-dble(nkids2_w(i)))+epsilon_w(1,i,sim)





 else if(type_i(i,sim).eq.3) then
 
 stskills(i,sim)=exp(theta(10)+theta(12)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+ &
                    & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim))

 
	lnwageM(i,sim)=constM(3)+theta(5)*dble(age_w(i))+theta(6)*(dble(age_w(i))**2.0d0)+theta(7)*dble(fem_w(i))+theta(8)*dble(perfec_w(i))+&
                   & theta(9)*dble(graddeg_w(i))+epsilon_w(2,i,sim)+bonus		
  lnwageV(i,sim) =ln_r+theta(10)+theta(12)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+ &
                    & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim) 
  lnwageNT(i,sim)=constNT(3)+theta(72)*dble(age_w(i))+theta(73)*(dble(age_w(i))**2.0d0)+theta(74)*dble(fem_w(i))+theta(75)*dble(perfec_w(i))+ &
                  & theta(76)*dble(graddeg_w(i))+epsilon_w(4,i,sim)
  uwM=lnwageM(i,sim)+theta(77)+theta(79)+theta(287)*dble(fem_w(i))
  uwV=lnwageV(i,sim)+theta(80)+theta(82)+theta(287)*dble(fem_w(i))
  uwNT=lnwageNT(i,sim)
  uwH=theta(83)+theta(85)+theta(86)*dble(fem_w(i))+theta(87)*dble(fem_w(i))*dble(nkids_w(i))+theta(88)*dble(age_w(i))+&
         & theta(194)*(dble(age_w(i)))**2.0d0+theta(89)*dble(nkids_w(i))+theta(90)*dble(nkids2_w(i))+&
         & theta(91)*(dble(nkids6_w(i))-dble(nkids2_w(i)))+epsilon_w(1,i,sim)  
 end if

 

 
    if(entry(mkt7_w(i)).eq.1.0d0) then
       umax=max(uwM,uwV,uwNT,uwH)
    else
       umax=max(uwM,uwNT,uwH)
    end if
 



   if(umax==uwM) then
    sM(i,sim)=1
    sV(i,sim)=0
    sNT(i,sim)=0
    sH(i,sim)=0
    swageM(i,sim)=exp(lnwageM(i,sim)) 
    swageV(i,sim)=0.0d0
    swageNT(i,sim)=0.0d0
	utility_work(i,sim)=uwM

   else if(umax==uwV) then
    sM(i,sim)=0
    sV(i,sim)=1
    sNT(i,sim)=0
    sH(i,sim)=0
    swageM(i,sim)=0.0d0
    swageV(i,sim)=exp(lnwageV(i,sim))
    swageNT(i,sim)=0.0d0
	utility_work(i,sim)=uwV

   else if (umax==uwNT) then
    sM(i,sim)=0
    sV(i,sim)=0
    sNT(i,sim)=1
    sH(i,sim)=0
    swageM(i,sim)=0.0d0
    swageV(i,sim)=0.0d0
    swageNT(i,sim)=exp(lnwageNT(i,sim))
	utility_work(i,sim)=uwNT

   else if (umax==uwH) then
    sM(i,sim)=0
    sV(i,sim)=0
    sNT(i,sim)=0
    sH(i,sim)=1  
    swageM(i,sim)=0.0d0
    swageV(i,sim)=0.0d0
    swageNT(i,sim)=0.0d0
	utility_work(i,sim)=uwH

   else
    write(*,*) "Problem in subroutine simulate_casenw: did not find optimal choice for worker i, of type, sim number", i, wtype
    write(*,*) "WARNING: for some rason I could not find the optimal cjhoice at a legitimate simulation of the models' shocks"
   ! read(*,*) stopping
   end if 

 
end do !sim
end do !i



TSV=0.0d0
TotwagesM=0.0d0
SupV=0.0d0




  do mkt=1,n_mkt
    do i=1,n_w
      do sim=1,D
        if(mkt7_w(i).eq.mkt) then

            SupV(mkt)=SupV(mkt)+id_w(2,i)*sV(i,sim)/dble(D)
            TSV(mkt)=TSV(mkt)+id_w(2,i)*sV(i,sim)*stskills(i,sim)/dble(D)
            TotwagesM(mkt)=TotwagesM(mkt)+id_w(2,i)*sM(i,sim)*swageM(i,sim)/dble(D)

        end if
      end do !sim
    end do !i



  end do !mkt

!Now compute the average abilities of workers that will be used to simulate parents




awM_sim=0.0d0
awV_sim=0.0d0
SM_sim=0.0d0
SV_sim=0.0d0

tsm2=0.0d0
tsv2=0.0d0
tst2=0.0d0
abilityM=0.0d0
abilityV=0.0d0



zeroSV_sim=0.0d0
zeroSM_sim=0.0d0

 
     do i=1,n_w

     mkt=mkt7_w(i)
 do sim=1,D

     if(sM(i,sim).eq.1.0d0) then
       abilityM=abilityM+stskills(i,sim)*id_w(2,i)
       tsm2=tsm2+id_w(2,i)
       SM_sim(mkt)=SM_sim(mkt)+id_w(2,i)
       awM_sim(mkt)=awM_sim(mkt)+stskills(i,sim)*id_w(2,i)
     end if

    if(sV(i,sim).eq.1.0d0) then
       abilityV=abilityV+stskills(i,sim)*id_w(2,i)
       tsv2=tsv2+id_w(2,i)
      SV_sim(mkt)=SV_sim(mkt)+id_w(2,i)
      awV_sim(mkt)=awV_sim(mkt)+stskills(i,sim)*id_w(2,i)
    end if

   if(sV(i,sim).eq.1.0d0.OR.sM(i,sim).eq.1.0d0) then
    tst2=tst2+id_w(2,i)
    abilityT=abilityT+stskills(i,sim)*id_w(2,i)

  end if
  end do !sim
   end do !i




     do mkt=1,n_mktvd
   if(SV_sim(mkt).ne.0.0d0) then
      awV_sim(mkt)=awV_sim(mkt)/SV_sim(mkt)
   else
      awV_sim(mkt)=-99.0d0
      zeroSV_sim(mkt)=1.0d0 
   end if
   if(SM_sim(mkt).ne.0.0d0) then
      awM_sim(mkt)=awM_sim(mkt)/SM_sim(mkt)
   else
     awM_sim(mkt)=-99.0d0
    zeroSM_sim(mkt)=1.0d0
   end if
    end do !mkt
      

!ability variables are nationwide, whereas awV/M variables are by market
if(tsm2.ne.0.0d0) then
     abilityM=abilityM/tsm2
  else
     abilityM=-99.0d0
end if

if(tsv2.ne.0.0d0) then
     abilityV=abilityV/tsv2
  else
     abilityV=-99.0d0
end if

if(tst2.ne.0.0d0) then
abilityT=abilityT/tst2

end if

if(case.eq.0) then




outcomes0(rM_int,4)=abilityT
outcomes0(rM_int,5)=abilityM
outcomes0(rM_int,6)=abilityV

outcomes0(rM_int,9)=tsm2
outcomes0(rM_int,10)=tsv2


write(1,*) ""
write(1,*) "teachers ability", abilityT
write(1,*) "teachers ability in M, V", abilityM, abilityV




else if (case.eq.1) then





outcomes1(rM_int,4)=abilityT
outcomes1(rM_int,5)=abilityM
outcomes1(rM_int,6)=abilityV

outcomes1(rM_int,9)=tsm2
outcomes1(rM_int,10)=tsv2


write(1,*) ""
write(1,*) "teachers ability", abilityT
write(1,*) "teachers ability in M, V", abilityM, abilityV


else if (case.eq.5) then


outcomes05(rM_int,4)=abilityT
outcomes05(rM_int,5)=abilityM
outcomes05(rM_int,6)=abilityV

outcomes05(rM_int,9)=tsm2
outcomes05(rM_int,10)=tsv2


write(1,*) ""
write(1,*) "teachers ability", abilityT
write(1,*) "teachers ability in M, V", abilityM, abilityV

end if


!Write dataset to file


if(case.eq.0) then
write(*,*) "writing simworkers_counterfactual_bonus.txt, for the case of the 2017 reform, rM=rM_reform"

print_dataset=1
if(print_dataset.eq.1.AND.rM.eq.rM_reform) then
open(unit=1002, file='./simworkers_counterfactual_bonus.txt')

do i=1,n_w


       write(1002,*) id_w(1,i), id_w(2,i), 1,  type_i(i,1), mkt7_w(i), graddeg_w(i), perfec_w(i), nkids_w(i), nkids2_w(i), nkids6_w(i), age_w(i), fem_w(i), &
       & peduc_w(i), m_w(i), v_w(i), nt_w(i), h_w(i),wage_w(i), swageM(i,1),swageV(i,1),swageNT(i,1), sM(i,1), sV(i,1), &
       & sNT(i,1), sH(i,1), stskills(i,1),r_used(mkt7_w(i)),  utility_work(i,1)



end do
close(1002)
end if

else if (case.eq.1) then
print_dataset=0
if(print_dataset.eq.1) then


!write(*,*) "writing simworkers_count_1.txt"
open(unit=1002, file='./simworkers_count_rm1_case1.txt')

do i=1,n_w


       write(1002,*) id_w(1,i), 1, id_w(2,i), type_iwglobal(i,1), mkt7_w(i), graddeg_w(i), perfec_w(i), nkids_w(i), nkids2_w(i), nkids6_w(i), age_w(i), fem_w(i), &
       & peduc_w(i), m_w(i), v_w(i), nt_w(i), h_w(i),wage_w(i), swageM(i,1),swageV(i,1),swageNT(i,1), sM(i,1), sV(i,1), &
       & sNT(i,1), sH(i,1), stskills(i,1),r_used(mkt7_w(i))



end do
close(1002)
end if



end if !case



end subroutine simdata_workers2_gvmt