MODULE Datasets
! This module contains the datasets

! DATASETS

    
    !I will only read in casen parents full and casen workers imputed;
    !Sample sizes
    integer, parameter       :: n_mkt=18 !number of markets used, common to all datasets
    integer, parameter       ::  n_w=5471, n_cp=21589 !number of primary and secondary students in casen_parents   
           !n_cp=26,641 if keep mincome<0      !It includes seconda media and quarto basicol. Income negative only if at home, otherwise never missing
    integer, parameter       :: n_cp2=5000    
      integer, parameter     :: n_s=100000   
    
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !CASEN PARENTS _cp
    !Xh=family characteristics
    real(8)                  :: id_cp(2,n_cp2) !vector of id's and weights
    integer                  :: mkt7_cp(n_cp2), mkt7v2_cp(n_cp2)
    real(8),dimension(n_cp2) :: minc_cp, peduc_cp
    integer,dimension(n_cp2) :: m_cp, v_cp, primaria_cp, urb_cp, nfam_cp, fem_cp, unempl_cp, blue_cp , age_cp    
    real(8)                  :: TOTweights_cp    !sum of weights in entire casen parents, i.e. size of pop it represents...
    
          
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !UNIQUE WORKERS _w
    real(8)                 :: id_w(2,n_w)
    integer                 :: mkt7_w(n_w)
    real(8)                 :: wage_w(n_w),  peduc_w(n_w)
    integer,dimension(n_w) ::  graddeg_w, perfec_w, nkids_w, nkids2_w, nkids6_w, age_w, fem_w
    integer,dimension(n_w) ::  h_w, m_w, v_w, nt_w   !If someone is imputed as in U, I assign them to NT
                                                                
    real(8)                 :: TOTweights_w
    
   
                              
    
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  
   !SIMCE06 4 and 10noinitial together
    real(8)                 :: id_s(n_s)
    real(8)                 :: mtuition_s(n_s), standability_s(n_s), mincome_s(n_s), peduc_s(n_s) !tuition is expressed in 100mila pesos 
    integer, dimension(n_s) :: primaria_s, rural_s, nfam_s, fem_s, unempl_s, blue_s, m_s, v_s, mkt7_s
                     

    
    
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !Mkt characteristics 
    !real(8)             :: mkt_char(23,n_mkt)
    real(8),dimension(n_mkt) ::  mkt7,  size_mkt7, educ_mkt7,   sdeduc_mkt7, blue_mkt7,mincome_mkt7, sdminc_mkt7, fona_mkt7, fonb_mkt7, fonc_mkt7, fond_mkt7,&
                             &   isapre_mkt7, chilesol_mkt7, rural_mkt7, unempl_mkt7, nowork_mkt7, nsub_mkt7, r_13, r_15, Norte, Central, Sur, numM, numV, numU,&
                             &   Drural_mkt7, Dchilsol_mkt7,studM_mkt7,  studV_mkt7,  sharestudV_mkt7, teachM_mkt7, imp_teachV_mkt7(10,n_mkt), &
                             &   imp_shareteachV_mkt7(10,n_mkt), imp_studteachV(10,n_mkt), studteachM, mean_maxpv

     integer, dimension(n_mkt) :: pvd_cat, educd_cat, mincomed_cat, Dblue_mkt7


END MODULE Datasets



