subroutine neg_prof(x,mkt, shock_cost_iter, pv, neg_prof_value)

USE VarDef

IMPLICIT NONE

double precision, intent(in)   :: x,  shock_cost_iter, pv
integer, intent(in)            :: mkt
real(8) , intent(out)          :: neg_prof_value
double precision               :: ln_r


integer  :: mkt_index
real(8)      :: unit_revenue, unit_fellow, EPV, DV, TSV, SV, awV, awM, zeroSV, zeroSM


 !  write(*,*) "Inside neg_prof"
 !  write(*,*) "mkt", mkt

    ln_r=log(x)
      call simulate_workers_mkt(mkt, ln_r,awV, awM, SV, TSV, zeroSM, zeroSV )
      call simulate_parents_mkt(mkt, pv, zeroSM, zeroSV, awM,awV, DV, EPV )

   !  write(*,*) "DV=", DV



       if(DV.ne.0.0d0.AND.SV.ne.0.0d0) then
           !write profit function using actual governmental formulas
           if(0.50d0*oneUSE<EPV.le.oneUSE) then
              unit_revenue=pv-0.10d0*(EPV-0.50d0*oneUSE)
           else if (oneUSE<EPV.le.2.0d0*oneUSE) then
              unit_revenue=pv-0.10d0*0.50d0*oneUSE-0.20d0*(EPV-oneUSE)
           else if (2.0d0*oneUSE<EPV)  then
              unit_revenue=pv-0.10d0*0.50d0*oneUSE-0.20d0*oneUSE-0.350d0*(EPV-2.0d0*oneUSE)
           end if 
        
           if(EPV.le.oneUSE) then
             unit_fellow=0.050d0*EPV
           else if (oneUSE<EPV.le.2.0d0*oneUSE) then
             unit_fellow=0.050d0*oneUSE+0.070d0*(EPV-oneUSE)
           else if(2.0d0*oneUSE<EPV) then
             unit_fellow=0.050d0*oneUSE+0.070d0*oneUSE+0.10d0*(EPV-2.0d0*oneUSE)
           end if

        neg_prof_value=-(    (unit_revenue-unit_fellow)*DV-(theta2(2)+shock_cost_iter)*DV-theta2(3)*DV**2.0d0&
                                   &-(exp(ln_r)*TSV)-theta2(4)*((DV/SV)/45.0d0)    )

      else
         neg_prof_value=1000000000000000000000000.0d0
      end if





end