!reads in abilities of workers in equilibrium


subroutine simulate_parents(pv, zeroSM, zeroSV, awM,awV,epsilon_p, type_ip, DV, EPV )
USE VarDef
USE Datasets
IMPLICIT NONE


real(8), intent(in)  :: pv, awM(n_mkt),awV(n_mkt)
real(8), intent(in)  :: epsilon_p(3,n_s,D) 
integer, intent(in) :: type_ip(n_s,D)
real(8), intent(in)  ::  zeroSM(n_mkt), zeroSV(n_mkt)
real(8), intent(out) :: DV(n_mkt), EPV(n_mkt)

integer, parameter   :: Dsimce=50
integer   :: noevalSIMCE, temp_var(n_s) 


real(8)  :: pv_h(n_s), ucM,ucV, awM_scalar, awV_scalar, ucmax, simcM_uncondSIMCE(n_s)

real(8)  :: simM(n_s,D), simV(n_s,D), sim_apv(n_s,D)
real(8)  :: simca(n_s,D), simcaM(n_s,D) , simcaV(n_s,D)



real(8)   :: beta0M(n_s), beta0V(n_s)  !this is the constant for type 1 and it varies by mkt
!real(8)   :: beta0V_21(n_s), beta0V_31(n_s)

real(8)   :: avg_tsM, avg_tsV, denomM, denomV, avg_simcaM, avg_simcaV, avg_fracV !average test scores for diagnostic purposes

integer  :: report  !if =1, it reports the values of the test scores for diagnostic purposes
         
 

           

integer :: i, sim, ctype, stopping, cat, idum, mkt, assigned(n_s,D), sV(n_s,D)

real(8)  :: weight(n_s), den_weight(n_mkt)

!IMPOTANT: pv is the price charged by the school, the family pays pv-voucher

!write(*,*) "Inside simulate parents"


report=0
assigned=0
simca=0.0d0


noevalSIMCE=0

den_weight=0.0d0




!Computing individual level price that each family would have to pay if they chose the V school in their market 
!This depends on the fellowship that each family is eligible for
    
    do i=1,n_s   
       pv_h(i)=theta(162)+theta(163)*(pv-voucher)+theta(164)*dble(primaria_s(i))+theta(165)*dble(nfam_s(i))+& 
                  &theta(169)*dble(rural_s(i))+theta(171)*mincome_s(i)
    
      if(pv_h(i)>pv-voucher) then
        pv_h(i)=pv-voucher
      else if (pv_h(i)<0.0d0) then      
        pv_h(i)=0.0d0
      end if   

 !Assign correct beta0M and beta0V
  if(mkt7_s(i).eq.1) then
     den_weight(1)=den_weight(1)+1.0d0
     beta0M(i)=theta(110)
     beta0V(i)=theta(113)

  
   else if (mkt7_s(i).eq.2) then
     den_weight(2)=den_weight(2)+1.0d0
     beta0M(i)=theta(199)
     beta0V(i)=theta(216)


  
   else if (mkt7_s(i).eq.3) then
     den_weight(3)=den_weight(3)+1.0d0
     beta0M(i)=theta(200)
     beta0V(i)=theta(217)



   else if (mkt7_s(i).eq.4) then
     den_weight(4)=den_weight(4)+1.0d0
     beta0M(i)=theta(201)
     beta0V(i)=theta(218)



   else if (mkt7_s(i).eq.5) then
     den_weight(5)=den_weight(5)+1.0d0
     beta0M(i)=theta(202)
     beta0V(i)=theta(219)




   else if (mkt7_s(i).eq.6) then
     den_weight(6)=den_weight(6)+1.0d0
     beta0M(i)=theta(203)
     beta0V(i)=theta(220)




   else if (mkt7_s(i).eq.7) then
     den_weight(7)=den_weight(7)+1.0d0
     beta0M(i)=theta(204)
     beta0V(i)=theta(221)




   else if (mkt7_s(i).eq.8) then
     den_weight(8)=den_weight(8)+1.0d0
     beta0M(i)=theta(205)
     beta0V(i)=theta(222)




   else if (mkt7_s(i).eq.9) then
     den_weight(9)=den_weight(9)+1.0d0
     beta0M(i)=theta(206)
     beta0V(i)=theta(223)




   else if (mkt7_s(i).eq.10) then
     den_weight(10)=den_weight(10)+1.0d0
     beta0M(i)=theta(207)
     beta0V(i)=theta(224)




   else if (mkt7_s(i).eq.11) then
     den_weight(11)=den_weight(11)+1.0d0
     beta0M(i)=theta(208)
     beta0V(i)=theta(225)




   else if (mkt7_s(i).eq.12) then
     den_weight(12)=den_weight(12)+1.0d0
     beta0M(i)=theta(209)
     beta0V(i)=theta(226)




   else if (mkt7_s(i).eq.13) then
     den_weight(13)=den_weight(13)+1.0d0
     beta0M(i)=theta(210)
     beta0V(i)=theta(227)




   else if (mkt7_s(i).eq.14) then
     den_weight(14)=den_weight(14)+1.0d0
     beta0M(i)=theta(211)
     beta0V(i)=theta(228)




   else if (mkt7_s(i).eq.15) then
     den_weight(15)=den_weight(15)+1.0d0
     beta0M(i)=theta(212)
     beta0V(i)=theta(229)




   else if (mkt7_s(i).eq.16) then
     den_weight(16)=den_weight(16)+1.0d0
     beta0M(i)=theta(213)
     beta0V(i)=theta(230)




   else if (mkt7_s(i).eq.17) then
     den_weight(17)=den_weight(17)+1.0d0
     beta0M(i)=theta(214)
     beta0V(i)=theta(231)




   else if (mkt7_s(i).eq.18) then
     den_weight(18)=den_weight(18)+1.0d0
     beta0M(i)=theta(215)
     beta0V(i)=theta(232)



   end if


    end do !i



!############### Compute simulated choices of parents #########################################
!############### Compute simulated accepted test scores of kids (=0 if sector not chosen) #####
!choice probabilities of parents given teachers' abilities

 
!write(*,*) "INSIDE SIMDATA SIMCE 2"




! draw the baseline choices of parents and keep them fixed (must simulate this first, with baseline simulations program)
open(unit=878571,file='./parents_baseline_choices.txt')
  do i=1,n_s
    
	   read(878571,*) temp_var(i), sV(i,1)

   
  end do

close(878571)
do i=1,n_s
 
  do  sim=1, D
  if(type_ip(i, sim).eq.1) then
  ucM=beta0M(i)+theta(116)*awM(mkt7_s(i))+theta(119)*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+theta(120)*dble(peduc_s(i))+&
         &epsilon_p(1,i,sim)+theta(123)*log(mincome_s(i))+theta(124)+theta(234)*dble(primaria_s(i))+theta(235)*dble(rural_s(i))+epsilon_p(3,i,sim) 


   ucV=beta0V(i)+theta(242)*awV(mkt7_s(i))+theta(236)*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+theta(239)*dble(peduc_s(i))+&
                &epsilon_p(2,i,sim)+theta(123)*log(mincome_s(i)-pv_h(i))


   
   else if(type_ip(i,sim).eq.2) then
  ucM=beta0M(i)+theta(111)+(theta(116)+theta(117))*awM(mkt7_s(i))+(theta(119)+theta(249))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+(theta(120)+theta(251))*dble(peduc_s(i))+&
               &epsilon_p(1,i,sim)+(theta(123)+theta(197))*log(mincome_s(i))+theta(124)+theta(125)+theta(234)*dble(primaria_s(i))+theta(235)*dble(rural_s(i))+epsilon_p(3,i,sim)  
  

  ucV=beta0V(i)+theta(114)+(theta(242)+theta(243))*awV(mkt7_s(i))+(theta(236)+theta(237))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
        &(theta(239)+theta(240))*dble(peduc_s(i))+&
        &epsilon_p(2,i,sim)+(theta(123)+theta(197))*log(mincome_s(i)-pv_h(i)) 
  
   else if (type_ip(i,sim).eq.3) then
  ucM=beta0M(i)+theta(112)+(theta(116)+theta(118))*awM(mkt7_s(i))+(theta(119)+theta(250))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
         &(theta(120)+theta(252))*dble(peduc_s(i))+&
         &epsilon_p(1,i,sim)+(theta(123)+theta(198))*log(mincome_s(i))+theta(124)+theta(126)+theta(234)*dble(primaria_s(i))+theta(235)*dble(rural_s(i))+epsilon_p(3,i,sim)
    
  ucV=beta0V(i)+theta(115)+(theta(242)+theta(244))*awV(mkt7_s(i))+(theta(236)+theta(238))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
        &(theta(239)+theta(241))*dble(peduc_s(i))+&
        &epsilon_p(2,i,sim)+(theta(123)+theta(198))*log(mincome_s(i)-pv_h(i))

    end if     
  
  
  
   

       if(sV(i,sim).eq.1) then !go to V
        ucmax=ucV
            simV(i,sim)=1.00d0
             sim_apv(i,sim)=pv_h(i) 
            assigned(i,sim)=1
        else if (sV(i,sim).eq.0) then !go to M
        ucmax=ucM  
              simV(i,sim)=0.0d0
               sim_apv(i,sim)=0.0d0
          assigned(i,sim)=1   
       end if


!
           assigned(i,sim)=1
    !   end if
     
     if(ucmax==ucM) then
               simV(i,sim)=0.0d0
               sim_apv(i,sim)=0.0d0
           

           
     else if (ucmax==ucV) then
             simV(i,sim)=1.00d0
             sim_apv(i,sim)=pv_h(i)   
         
      else if(ucmax.ne.ucV.AND.ucmax.ne.ucM.AND.assigned(i,sim).eq.0) then
         write(*,*) "Problem in sbroutine simulate_simce: did not find optimal choice for parents. family i=", i
      end if  


end do !sim
end do !i  

!First, build weights using total number of ppl in each market according to csaen parents, where the weights represent the individuals in the market that I've chosen
!and only in the M and V schools


do i=1,n_s

     if( mkt7_s(i).eq.1) then
       weight(i)=69964.996/ den_weight(1)
     end if

     if( mkt7_s(i).eq.2) then
       weight(i)=97091.995/den_weight(2)
     end if


     if( mkt7_s(i).eq.3) then
       weight(i)=80431.002/ den_weight(3)
     end if


     if( mkt7_s(i).eq.4) then
       weight(i)=34857.001/ den_weight(4)
     end if


     if( mkt7_s(i).eq.5) then
       weight(i)=145449.02/ den_weight(5)
     end if


     if( mkt7_s(i).eq.6) then
       weight(i)=94161.988/ den_weight(6)
     end if


     if( mkt7_s(i).eq.7) then
       weight(i)=141275.01/ den_weight(7)
     end if


     if( mkt7_s(i).eq.8) then
       weight(i)=58556.004/ den_weight(8)
     end if


     if( mkt7_s(i).eq.9) then
       weight(i)=80961.998/ den_weight(9)
     end if


     if( mkt7_s(i).eq.10) then
       weight(i)=35555.997/ den_weight(10)
     end if


     if( mkt7_s(i).eq.11) then
       weight(i)=70407.012/ den_weight(11)
     end if


     if( mkt7_s(i).eq.12) then
       weight(i)=34381.997/ den_weight(12)
     end if


     if( mkt7_s(i).eq.13) then
       weight(i)=132718/ den_weight(13)
     end if


     if( mkt7_s(i).eq.14) then
       weight(i)=18074.999/ den_weight(14)
     end if


     if( mkt7_s(i).eq.15) then
       weight(i)=573627.83/ den_weight(15)
     end if


     if( mkt7_s(i).eq.16) then
       weight(i)=137462/ den_weight(16)
     end if

     if( mkt7_s(i).eq.17) then
       weight(i)=61226.993/ den_weight(17)
     end if

     if( mkt7_s(i).eq.18) then
       weight(i)=17787.006/ den_weight(18)
     end if


end do


!Now compute EPV and DV

DV=0.0d0
EPV=0.0d0

   
  do i=1,n_s

    mkt=mkt7_s(i)
    do sim=1,D
      if(simV(i,sim).eq.1.0d0) then
       DV(mkt)=DV(mkt)+weight(i)/dble(D)
       EPV(mkt)=EPV(mkt)+sim_apv(i,sim)*weight(i)/dble(D)
      end if
     end do
   end do

  do mkt=1,n_mkt
     if(DV(mkt).ne.0.0d0) then
       EPV(mkt)=EPV(mkt)/DV(mkt)
     end if
  end do




end subroutine simulate_parents