MODULE VarDef
IMPLICIT NONE


    
 

    integer, parameter   :: p=304
    integer, parameter   :: NWType=3, NCType=3 !Number of types of workers and of kids
    
    real(8)              :: theta(p) !vector of parameters

    real(8), parameter   :: cs_cap=100.0d0,p_cap=78000.0d0/100000.0d0 
                                                                     
    real(8), parameter   :: b=1.07d0 , voucher=27391.903/100000.0d0      
    real(8), parameter   :: voucher_prim=24856.88/100000.0d0, voucher_med=29926.925
    integer, parameter   :: D=1000, Deld=100 !Number of simulated draws
    integer, parameter   :: Dpr=100 !number of shocks to the per-pupil cost, used to generate distribution of optimal prices p and r 300
                                 

    !Number of observations in profit interpolating regression
    integer, parameter   :: rnodes=30
    integer, parameter   :: pvnodes=30  
    integer, parameter   :: iter_num=900  !iter_num=rnodes*pvnodes
   
   !Sample sizes
    integer, parameter    :: n_mktvd=18 !number of markets used, common to all datasets
    integer, parameter    :: n_cpvd=21589, n_cwvd=3520 !number of primary and secondary students in casen_parents  
     integer, parameter   :: n_cp2vd=5000      
   integer, parameter     :: n_wvd=5471, n_svd=100000  
    
     real(8)              :: StartTime, EndTime, MidTime, BeginningTime
     
    
    
    
    
    
    
    


END MODULE VarDef